/*****************************************************

		Platinen Layout fr ATARI ST in TURBO C
					Thomas Nau (c) 1990
	license: GNU GPL 2+ (see ../COPYING)

*****************************************************/

/* Standart INCLUDE files */

#include <stdio.h>
#include <string.h>
#include <linea.h>
#include <tos.h>

#define L_CURSOR

#include "l_incl.h"     /* alle anderen INCLUDE Files */

/******************************************

		cursor ein

******************************************/
void cursor_on()
{
	if (!cursor.on)
	{
		cursor_chg();
		cursor.x = cursor.nx;
		cursor.y = cursor.ny;
		cursor.on = TRUE;
		cursor_draw();
		if (act_line.on)
		{
			set_angle();
			act_line_draw();
		}
		if (act_block.on == 2)
			act_block_draw();
	}
}

/******************************************

		cursor aus

******************************************/
void cursor_off()
{
	if (cursor.on)
	{
		cursor.on = FALSE;
		cursor_draw();
		if (act_line.on)
			act_line_draw();
		if (act_block.on == 2)
			act_block_draw();
	}
}

/******************************************

		cursor neu

******************************************/
void cursor_new()
{
	cursor_draw();
	cursor.x = cursor.nx;
	cursor.y = cursor.ny;
	cursor_draw();
	if (act_line.on)
	{
		act_line_draw();
		set_angle();
		act_line_draw();
	}
}

/******************************************

		cursor off, act_block on draw_mbl()
		
******************************************/
void restore_mbl()
{
	cursor_off();
	if (mv_head.blk)
		act_block_draw();
	draw_mbl();
}

/******************************************

		holt Zielblock aus header

******************************************/
int mbl_head()
{
	mv_head.x = head.offx;
	mv_head.y = head.offy;
	mv_head.x1 = head.minx;
	mv_head.y1 = head.miny;
	mv_head.x2 = head.maxx;
	mv_head.y2 = head.maxy;
	mv_head.blk = FALSE;
	return(cursor_mbl());
}

/******************************************

		holt Zielblock aus act_block

******************************************/
int mbl_actblk()
{
	mv_head.x = mv_head.x1 = act_block.x1;
	mv_head.y = mv_head.y1 = act_block.y1;
	mv_head.x2 = act_block.x2;
	mv_head.y2 = act_block.y2;
	mv_head.blk = TRUE;
	return(cursor_mbl());
}

/******************************************

		wartet auf linke Maustaste und zeichnet Block neu

******************************************/
int cursor_mbl()
{
	int		lflag, rflag, x, y, key;
	
	rflag = lflag = key = 0;
	draw_mbl();
	if (mv_head.blk)
		act_block_draw();
	do
	{
		if (Cconis())
			if ((key = do_curkeys()) == 0)
			{
				draw_mbl();
				cursor.x = cursor.nx;
				cursor.y = cursor.ny;
				draw_mbl();
				status();
			}
			else
				if (key > 0)
				{
					draw_mbl();
					if (mv_head.blk)
						act_block_draw();
					return(TRUE);
				}
		if (Vdiesc->mouse_bt)
		{
			lflag = Vdiesc->mouse_bt & 1;
			rflag = Vdiesc->mouse_bt & 2;
		}
		else
			if (rflag)
			{
				rflag = 0;
				draw_mbl();
				if (++info.rot > 3) info.rot = 0;
				draw_mbl();
				status();
			}
		if (cursor_chg())
		{
			draw_mbl();
			cursor.x = cursor.nx;
			cursor.y = cursor.ny;
			draw_mbl();
			status();
		}
		act_coord(&x, &y);
		if (cursor.x >= XSCREEN-20 || cursor.y >= YSCREEN-20 ||
			(x > 20 && y > 20 && (cursor.x <= 20 || cursor.y <= 20)))
		{
			scr_center(x, y);
			update_scr();
			restore_mbl();
		}
	} while((Vdiesc->mouse_bt || !lflag) && key >= 0);
	draw_mbl();
	if (mv_head.blk)
		act_block_draw();
	return(FALSE);
}

/******************************************

		Rechteck zum Verschieben zeichnen

******************************************/
void draw_mbl()
{
	register	int		xa, ya, xb, yb;
				int		x1, x2, y1, y2, x0, y0;

	scr_coord(mv_head.x, mv_head.y, &x0, &y0);
	scr_coord(mv_head.x1, mv_head.y1, &x1, &y1);
	scr_coord(mv_head.x2, mv_head.y2, &x2, &y2);
	switch(info.rot)
	{
		case 1 : xa = -(y2-y0); ya = (x2-x0);
				 xb = -(y0-y1); yb = (x0-x1); break;
		case 2 : xa = -(x2-x0); ya = -(y2 -y0);
				 xb = -(x0-x1); yb = -(y0 -y1); break;
		case 3 : xa = (y2-y0); ya = -(x2-x0);
				 xb = (y0-y1); yb = -(x0-x1); break;
		default: xa = (x2-x0); ya = (y2-y0);
				 xb = (x0-x1); yb = (y0-y1); break;
	}
	o_hordot(cursor.x -xb, cursor.x +xa, cursor.y -yb);
	o_hordot(cursor.x -xb, cursor.x +xa, cursor.y +ya);
	o_verdot(cursor.x -xb, cursor.y -yb, cursor.y +ya);
	o_verdot(cursor.x +xa, cursor.y -yb, cursor.y +ya);
	if (xb && xa)
		o_verdot(cursor.x, cursor.y -yb, cursor.y +ya);
	if (yb && ya)
		o_hordot(cursor.x -xb, cursor.x +xa, cursor.y);
}

/******************************************

		cursor zeichnen

******************************************/
void cursor_draw()
{
	int		x, y;

	o_cursor(cursor.x, cursor.y);
	if (act_block.on == 1)
	{
		scr_coord(act_block.x1, act_block.y1, &x, &y);
		o_hordot(x, cursor.x, y);
		o_verdot(x, y, cursor.y);
	}
	status();
}

/******************************************

		cursor geaendert

******************************************/
int cursor_chg()
{
	register	int		x, y;

	x = (Vdiesc->gcurx /info.gfac) *info.gfac;
	y = (Vdiesc->gcury /info.gfac) *info.gfac;
	cursor.nx = x;
	cursor.ny = y;
	return((x != cursor.x || y != cursor.y) ? TRUE : FALSE);
}

/******************************************

		Cursor bewegen

******************************************/
void cursor_move(x, y)
int	x, y;
{
	Vdiesc->gcurx += x*info.gfac;
	Vdiesc->gcury += y*info.gfac;
	if (Vdiesc->gcurx < 0) 
		Vdiesc->gcurx = 0;
	else
		if (Vdiesc->gcurx > info.maxx)
			Vdiesc->gcurx = info.maxx;
	if (Vdiesc->gcury < 0) 
		Vdiesc->gcury = 0;
	else
		if (Vdiesc->gcury > info.maxy)
			Vdiesc->gcury = info.maxy;
	cursor.sx = Vdiesc->gcurx;
	cursor.sy = Vdiesc->gcury;
}

/******************************************

		Block Zeichnen zeichnen

******************************************/
void act_block_draw()
{
	int		x1, x2, y1, y2;

	scr_coord(act_block.x1, act_block.y1, &x1, &y1);
	scr_coord(act_block.x2, act_block.y2, &x2, &y2);
	o_verdot(x1, y1, y2);
	o_verdot(x2, y1, y2);
	o_hordot(x1, x2, y1);
	o_hordot(x1, x2, y2);
}

/******************************************

		Hilfslinie zeichnen

******************************************/
void act_line_draw()
{
	int		x1, x2, y1, y2;

	scr_coord(act_line.x1, act_line.y1, &x1, &y1);
	scr_coord(act_line.x2, act_line.y2, &x2, &y2);
	switch(act_line.d)
	{
		case	0	:
		case	4	:	o_verdot(x1, y1, y2); break;
		case	1	:
		case	5	:	o_urdot(x1, y1, x2, y2); break;
		case	2	:
		case	6	:	o_hordot(x1, x2, y1); break;
		case	3	:
		case	7	:	o_drdot(x1, y1, x2, y2); break;
		default		:	break;
	}
}

/******************************************

		aktuelle Koordinaten

******************************************/
void	plt_coord(x, y, cx, cy)
int	x, y;
int	*cx, *cy;
{
	*cx = (x /zoom[info.zoom]) +info.offx;
	*cy = (y /zoom[info.zoom]) +info.offy;
	*cx = (*cx /grid[info.grid]) *grid[info.grid];
	*cy = (*cy /grid[info.grid]) *grid[info.grid];
}

/******************************************

		aktuelle Koordinaten

******************************************/
void	act_coord(cx, cy)
int	*cx, *cy;
{
	*cx = (cursor.x /zoom[info.zoom]) +info.offx;
	*cy = (cursor.y /zoom[info.zoom]) +info.offy;
}

/******************************************

		aktuelle Bildschirmkoordinaten

******************************************/
void	scr_coord(x, y, sx, sy)
int	x, y, *sx, *sy;
{
	*sx = (x -info.offx) *zoom[info.zoom];
	*sy = (y -info.offy) *zoom[info.zoom];
}

/******************************************

		zentriert Bild auf Cursor

******************************************/
void scr_center(x, y)
int	x, y;
{
	int		dx, dy, oldx, oldy;

	oldx = x;
	oldy = y;
	x -= info.offx;
	y -= info.offy;
	dx = (((info.maxx/2) /info.gfac) *info.gfac) /zoom[info.zoom];
	dy = (((info.maxy/2) /info.gfac) *info.gfac) /zoom[info.zoom];
	info.offx += (x -dx);
	info.offy += (y -dy);
	if (info.offx < 0)
		info.offx = 0;
	else
		if (info.offx > XMAX -dx)
			info.offx = XMAX -dx;
	if (info.offy < 0)
		info.offy = 0;
	else
		if (info.offy > YMAX -dy)
			info.offy = YMAX -dy;
	info.offx = (info.offx /grid[GRIDMAX-1]) *grid[GRIDMAX-1];
	info.offy = (info.offy /grid[GRIDMAX-1]) *grid[GRIDMAX-1];
	scr_coord(oldx, oldy, &Vdiesc->gcurx, &Vdiesc->gcury);
	cursor_move(0, 0);
}

/******************************************

		Cursor speichern

******************************************/
void cursor_save()
{
	cursor_off();
	cursor_move(0, 0);
}

/******************************************

		Cursor herstellen

******************************************/
void cursor_rec()
{
	Vdiesc->gcurx = cursor.sx;
	Vdiesc->gcury = cursor.sy;
	cursor_move(0, 0);
	cursor_on();
}

/******************************************

		Statuszeile

******************************************/
void status()
{
	static		char	s[81];
	register	int		i;
				int		px, py;

	if (!info.stline) return;
	act_coord(&px, &py);
	sprintf(s, " %4i %4i,  T%-2i(%i) P%-2i(%i),  G%-2i  Z%i,  L%s(%c,%c),  S(%i)  R(%i%c)  %c",
			px, py,
			linewidth[info.ll], l_track[info.plane].n,
			dotwidth[info.dl], d_data.n,
			grid[info.grid], zoom[info.zoom],
			l_string, (char) (info.plane+49), (char) (info.cmplane+49),
			l_stack.n, info.rot,
			((info.mir == FALSE) ? ' ' : 'M'),
			((info.ctrl == FALSE) ? ' ' : 'C'));
	i = (int) strlen(s);
	while (i < 81) 
		s[i++] = ' ';
	s[81] = '\0';
	o_status(s);
}

/******************************************

		Page down

******************************************/
void page_down()
{
	int	i, x, y;

	plt_coord((XSCREEN+1)/2, YSCREEN, &x, &y);
	i = info.offx;
	scr_center(x, y);
	info.offx = i;
	update_scr();
}

/******************************************

		Page left

******************************************/
void page_left()
{
	int	i, x, y;

	if (!info.offx) return;
	plt_coord(0, (YSCREEN+1)/2, &x, &y);
	i = info.offy;
	scr_center(x, y);
	info.offy = i;
	update_scr();
}

/******************************************

		Page right

******************************************/
void page_right()
{
	int	i, x, y;

	plt_coord(XSCREEN, (YSCREEN+1)/2, &x, &y);
	i = info.offy;
	scr_center(x, y);
	info.offy = i;
	update_scr();
}

/******************************************

		Page up

******************************************/
void page_up()
{
	int	i, x, y;
	
	if (!info.offy) return;
	plt_coord((XSCREEN+1)/2, 0, &x, &y);
	i = info.offx;
	scr_center(x, y);
	info.offx = i;
	update_scr();
}
