/*****************************************************

		Platinen Layout fr ATARI ST in TURBO C
					Thomas Nau (c) 1990
	license: GNU GPL 2+ (see ../COPYING)

*****************************************************/

/* Standart INCLUDE files */

#include <stdio.h>
#include <stdlib.h>
#include <tos.h>
#include <ext.h>
#include <string.h>
#include <aes.h>
#include <linea.h>

#define L_FILE

#include "l_incl.h"     /* alle anderen INCLUDE Files */

/******************************************

		error ausgeben

******************************************/
void say_error(s)
char	*s;
{
	char	s1[80];

	o_clrstat();
	sprintf(s1, " %s (press any key...)", s);
	o_status(s);
	while (!Cconis());
	Cnecin();
	o_clrstat();
}

/******************************************

		header pruefen

******************************************/
int chk_head(x, y)
int	x, y;
{
	int		xmin, xmax, ymin, ymax;
	Header	h;

	h = head;
	h.minx -= h.offx;
	h.maxx -= h.offx;
	h.miny -= h.offy;
	h.maxy -= h.offy;
	switch(info.rot)
	{
		case	0	:	xmin = x + h.minx;
						xmax = x + h.maxx;
						ymin = y + h.miny;
						ymax = y + h.maxy;
						break;
		case	1	:	xmin = x - h.maxy;
						xmax = x - h.miny;
						ymin = y + h.minx;
						ymax = y + h.maxx;
						break;
		case	2	:	xmin = x - h.maxx;
						xmax = x - h.minx;
						ymin = y - h.maxy;
						ymax = y - h.miny;
						break;
		case	3	:	xmin = x + h.miny;
						xmax = x + h.maxy;
						ymin = y - h.maxx;
						ymax = y - h.minx;
						break;
		default		:	break;
	}
	if (xmin < 0 || xmax > XMAX || ymin < 0 || ymax > YMAX)
	{
		say_error("new modulesize too large !");
		return(TRUE);
	}
	else
		return(FALSE);
}

/******************************************

		Pins rotieren

******************************************/
void rot_dot(dt, n, x, y, h)
register	DotTyp	*dt;
register	int		n, x, y;
register	Header	*h;
{
	int		dx, dy;

	switch(info.rot)
	{
		case 1	:	while (n)
					{
						dx = dt->x -h->offx;
						dy = dt->y -h->offy;
						dt->x = x -dy;
						dt->y = y +dx;
						dt++;
						n--;
					}
					break;
		case 2	:	while (n)
					{
						dx = dt->x -h->offx;
						dy = dt->y -h->offy;
						dt->x = x -dx;
						dt->y = y -dy;
						dt++;
						n--;
					}
					break;
		case 3	:	while (n)
					{
						dx = dt->x -h->offx;
						dy = dt->y -h->offy;
						dt->x = x +dy;
						dt->y = y -dx;
						dt++;
						n--;
					}
					break;
		default	:	while (n)
					{
						dx = dt->x -h->offx;
						dy = dt->y -h->offy;
						dt->x = x +dx;
						dt->y = y +dy;
						dt++;
						n--;
					}
					break;
	}
}

/******************************************

		Linienrichtung setzen

******************************************/
void set_dir(lt)
register	LineTyp *lt;
{
	register	int		x, y;

	if (lt->x1 > lt->x2)
	{
		x = lt->x1; lt->x1 = lt->x2; lt->x2 = x;
		y = lt->y1; lt->y1 = lt->y2; lt->y2 = y;
	}
	if (lt->x1 == lt->x2)
	{
		if (lt->y1 > lt->y2)
		{
			y = lt->y1; lt->y1 = lt->y2; lt->y2 = y;
		}
		lt->d = 0;
	}
	else
		if (lt->y2 > lt->y1)
			lt->d = 1;
		else
			lt->d = ((lt->y1 == lt->y2) ? 2 : 3);
}

/******************************************

		Linien rotieren

******************************************/
void rot_line(lt, n, x, y, h)
register	LineTyp	*lt;
register	int		n, x, y;
register	Header	*h;
{
	int		dx, dy;

	switch(info.rot)
	{
		case 1	:	while (n)
					{
						dx = lt->x1 -h->offx;
						dy = lt->y1 -h->offy;
						lt->x1 = x -dy;
						lt->y1 = y +dx;
						dx = lt->x2 -h->offx;
						dy = lt->y2 -h->offy;
						lt->x2 = x -dy;
						lt->y2 = y +dx;
						set_dir(lt++);
						n--;
					}
					break;
		case 2	:	while (n)
					{
						dx = lt->x1 -h->offx;
						dy = lt->y1 -h->offy;
						lt->x1 = x -dx;
						lt->y1 = y -dy;
						dx = lt->x2 -h->offx;
						dy = lt->y2 -h->offy;
						lt->x2 = x -dx;
						lt->y2 = y -dy;
						set_dir(lt++);
						n--;
					}
					break;
		case 3	:	while (n)
					{
						dx = lt->x1 -h->offx;
						dy = lt->y1 -h->offy;
						lt->x1 = x +dy;
						lt->y1 = y -dx;
						dx = lt->x2 -h->offx;
						dy = lt->y2 -h->offy;
						lt->x2 = x +dy;
						lt->y2 = y -dx;
						set_dir(lt++);
						n--;
					}
					break;
		default	:	while (n)
					{
						dx = lt->x1 -h->offx;
						dy = lt->y1 -h->offy;
						lt->x1 = x +dx;
						lt->y1 = y +dy;
						dx = lt->x2 -h->offx;
						dy = lt->y2 -h->offy;
						lt->x2 = x +dx;
						lt->y2 = y +dy;
						lt++;
						n--;
					}
					break;
	}
}

/******************************************

		Texte rotieren

******************************************/
void rot_text(tt, n, x, y, h)
register	TextTyp	*tt;
register	int		n, x, y;
register	Header	*h;
{
	int		dx, dy;

	switch(info.rot)
	{
		case 1	:	while (n)
					{
						dx = tt->x -h->offx;
						dy = tt->y -h->offy;
						tt->x = x -dy;
						tt->y = y +dx;
						dx = tt->x1 -h->offx;
						dy = tt->y1 -h->offy;
						tt->x1 = x -dy;
						tt->y1 = y +dx;
						dx = tt->x2 -h->offx;
						dy = tt->y2 -h->offy;
						tt->x2 = x -dy;
						tt->y2 = y +dx;
						if ((tt->rot += 1) > 3) tt->rot -= 4;
						tt++;
						n--;
					}
					break;
		case 2	:	while (n)
					{
						dx = tt->x -h->offx;
						dy = tt->y -h->offy;
						tt->x = x -dx;
						tt->y = y -dy;
						dx = tt->x1 -h->offx;
						dy = tt->y1 -h->offy;
						tt->x1 = x -dx;
						tt->y1 = y -dy;
						dx = tt->x2 -h->offx;
						dy = tt->y2 -h->offy;
						tt->x2 = x -dx;
						tt->y2 = y -dy;
						if ((tt->rot += 2) > 3) tt->rot -= 4;
						tt++;
						n--;
					}
					break;
		case 3	:	while (n)
					{
						dx = tt->x -h->offx;
						dy = tt->y -h->offy;
						tt->x = x +dy;
						tt->y = y -dx;
						dx = tt->x1 -h->offx;
						dy = tt->y1 -h->offy;
						tt->x1 = x +dy;
						tt->y1 = y -dx;
						dx = tt->x2 -h->offx;
						dy = tt->y2 -h->offy;
						tt->x2 = x +dy;
						tt->y2 = y -dx;
						if ((tt->rot += 3) > 3) tt->rot -= 4;
						tt++;
						n--;
					}
					break;
		default	:	while (n)
					{
						dx = tt->x -h->offx;
						dy = tt->y -h->offy;
						tt->x = x +dx;
						tt->y = y +dy;
						dx = tt->x1 -h->offx;
						dy = tt->y1 -h->offy;
						tt->x1 = x +dx;
						tt->y1 = y +dy;
						dx = tt->x2 -h->offx;
						dy = tt->y2 -h->offy;
						tt->x2 = x +dx;
						tt->y2 = y +dy;
						tt++;
						n--;
					}
					break;
	}
}

/******************************************

		Elementblock setzen

******************************************/
void set_eblk(p)
EleTyp *p;
{
	int	x1, y1, x2, y2;

	x1 = MIN(p->x1, p->x2);
	x2 = MAX(p->x1, p->x2);
	y1 = MIN(p->y1, p->y2);
	y2 = MAX(p->y1, p->y2);
	p->x1 = x1;
	p->x2 = x2;
	p->y1 = y1;
	p->y2 = y2;
}

/******************************************

		Flaechen setzen

******************************************/
void set_ablk(p)
AreaTyp *p;
{
	int	x1, y1, x2, y2;

	x1 = MIN(p->x1, p->x2);
	x2 = MAX(p->x1, p->x2);
	y1 = MIN(p->y1, p->y2);
	y2 = MAX(p->y1, p->y2);
	p->x1 = x1;
	p->x2 = x2;
	p->y1 = y1;
	p->y2 = y2;
}

/******************************************

		Elemente rotieren

******************************************/
void rot_elem(et, n, x, y, h)
register	EleTyp	*et;
register	int		n, x, y;
register	Header	*h;
{
	int		dx, dy;

	switch(info.rot)
	{
		case 1	:	while (n)
					{
						dx = et->x1 -h->offx;
						dy = et->y1 -h->offy;
						et->x1 = x -dy;
						et->y1 = y +dx;
						dx = et->x2 -h->offx;
						dy = et->y2 -h->offy;
						et->x2 = x -dy;
						et->y2 = y +dx;
						dx = et->tx -h->offx;
						dy = et->ty -h->offy;
						et->tx = x -dy;
						et->ty = y +dx;
						dx = et->mx -h->offx;
						dy = et->my -h->offy;
						et->mx = x -dy;
						et->my = y +dx;
						if ((et->tr += 1) > 3) et->tr -= 4;
						set_eblk(et);
						et++;
						n--;
					}
					break;
		case 2	:	while (n)
					{
						dx = et->x1 -h->offx;
						dy = et->y1 -h->offy;
						et->x1 = x -dx;
						et->y1 = y -dy;
						dx = et->x2 -h->offx;
						dy = et->y2 -h->offy;
						et->x2 = x -dx;
						et->y2 = y -dy;
						dx = et->tx -h->offx;
						dy = et->ty -h->offy;
						et->tx = x -dx;
						et->ty = y -dy;
						dx = et->mx -h->offx;
						dy = et->my -h->offy;
						et->mx = x -dx;
						et->my = y -dy;
						if ((et->tr += 2) > 3) et->tr -= 4;
						set_eblk(et);
						et++;
						n--;
					}
					break;
		case 3	:	while (n)
					{
						dx = et->x1 -h->offx;
						dy = et->y1 -h->offy;
						et->x1 = x +dy;
						et->y1 = y -dx;
						dx = et->x2 -h->offx;
						dy = et->y2 -h->offy;
						et->x2 = x +dy;
						et->y2 = y -dx;
						dx = et->tx -h->offx;
						dy = et->ty -h->offy;
						et->tx = x +dy;
						et->ty = y -dx;
						dx = et->mx -h->offx;
						dy = et->my -h->offy;
						et->mx = x +dy;
						et->my = y -dx;
						if ((et->tr += 3) > 3) et->tr -= 4;
						set_eblk(et);
						et++;
						n--;
					}
					break;
		default	:	while (n)
					{
						dx = et->x1 -h->offx;
						dy = et->y1 -h->offy;
						et->x1 = x +dx;
						et->y1 = y +dy;
						dx = et->x2 -h->offx;
						dy = et->y2 -h->offy;
						et->x2 = x +dx;
						et->y2 = y +dy;
						dx = et->tx -h->offx;
						dy = et->ty -h->offy;
						et->tx = x +dx;
						et->ty = y +dy;
						dx = et->mx -h->offx;
						dy = et->my -h->offy;
						et->mx = x +dx;
						et->my = y +dy;
						et++;
						n--;
					}
					break;
	}
}

/******************************************

		Flaechen rotieren

******************************************/
void rot_area(at, n, x, y, h)
register	AreaTyp	*at;
register	int		n, x, y;
register	Header	*h;
{
	int		dx, dy;

	switch(info.rot)
	{
		case 1	:	while (n)
					{
						dx = at->x1 -h->offx;
						dy = at->y1 -h->offy;
						at->x1 = x -dy;
						at->y1 = y +dx;
						dx = at->x2 -h->offx;
						dy = at->y2 -h->offy;
						at->x2 = x -dy;
						at->y2 = y +dx;
						set_ablk(at);
						at++;
						n--;
					}
					break;
		case 2	:	while (n)
					{
						dx = at->x1 -h->offx;
						dy = at->y1 -h->offy;
						at->x1 = x -dx;
						at->y1 = y -dy;
						dx = at->x2 -h->offx;
						dy = at->y2 -h->offy;
						at->x2 = x -dx;
						at->y2 = y -dy;
						set_ablk(at);
						at++;
						n--;
					}
					break;
		case 3	:	while (n)
					{
						dx = at->x1 -h->offx;
						dy = at->y1 -h->offy;
						at->x1 = x +dy;
						at->y1 = y -dx;
						dx = at->x2 -h->offx;
						dy = at->y2 -h->offy;
						at->x2 = x +dy;
						at->y2 = y -dx;
						set_ablk(at);
						at++;
						n--;
					}
					break;
		default	:	while (n)
					{
						dx = at->x1 -h->offx;
						dy = at->y1 -h->offy;
						at->x1 = x +dx;
						at->y1 = y +dy;
						dx = at->x2 -h->offx;
						dy = at->y2 -h->offy;
						at->x2 = x +dx;
						at->y2 = y +dy;
						at++;
						n--;
					}
					break;
	}
}

/******************************************

		header lesen

******************************************/
int read_head(fp)
FILE	*fp;
{
	int	magic;

	if (fread(&magic, sizeof(int), 1, fp) != 1 || fread(&head, sizeof(Header), 1, fp) != 1)
	{
		say_error("head read error");
		return(TRUE);
	}
	if (magic != MAGIC)
	{
		say_error("wrong file format !");
		return(TRUE);
	}
	return(FALSE);
}

/******************************************

		Pins mischen

******************************************/
int merg_dots(fp, x, y)
FILE	*fp;
int		x, y;
{
	register	DotTyp	*dt;
	register	EleTyp	*et;
				int		n;

	if (fread(&n, sizeof(int), 1, fp) != 1)
	{
		say_error("pin-head read error");
		return(TRUE);
	}
	if (n+d_data.n >= MAXDOTS)
	{
		say_error("too many pins !");
		return(TRUE);
	}
	dt = d_data.d +d_data.n;
	if (n)
		if (fread(dt, sizeof(DotTyp), n, fp) != n)
		{
			say_error("pin-data read error");
			return(TRUE);
		}
	d_data.n += n;
	rot_dot(dt, n, x, y, &head);
	if (fread(&n, sizeof(int), 1, fp) != 1)
	{
		say_error("element-head read error");
		return(TRUE);
	}
	if (n+element.n >= MAXELEM)
	{
		say_error("too many elements !");
		return(TRUE);
	}
	et = element.e +element.n;
	if (n)
		if (fread(et, sizeof(EleTyp), n, fp) != n)
		{
			say_error("element-data read error");
			return(TRUE);
		}
	element.n += n;
	rot_elem(et, n, x, y, &head);
	return(FALSE);
}

/******************************************

		Layers mischen

******************************************/
int merg_layer(fp, x, y)
FILE	*fp;
int		x, y;
{
	register	LineTyp	*lt;
	register	AreaTyp	*at;
	register	TextTyp	*tt;
	register	int		i;
				int		n, na, nt;

	for (i = 0; i < MAXLAYER; i++)
	{
		if (fread(&n, sizeof(int), 1, fp) != 1 ||
			fread(&na, sizeof(int), 1, fp) != 1 ||
			fread(&nt, sizeof(int), 1, fp) != 1)
		{
			say_error("layer-head read error");
			return(TRUE);
		}
		lt = l_track[i].l +l_track[i].n;
		at = l_track[i].a +l_track[i].na;
		tt = l_track[i].t +l_track[i].nt;
		if (n +l_track[i].n >= MAXLINES)
		{
			say_error("too many lines !");
			return(TRUE);
		}
		if (n)
		{
			if (fread(lt, sizeof(LineTyp), n, fp) != n)
			{
				say_error("line-data read error");
				return(TRUE);
			}
			l_track[i].n += n;
			rot_line(lt, n, x, y, &head);
		}
		if (na +l_track[i].na >= MAXAREA)
		{
			say_error("too many filled areas !");
			return(TRUE);
		}
		if (na)
		{
			if (fread(at, sizeof(AreaTyp), na, fp) != na)
			{
				say_error("area-data read error");
				return(TRUE);
			}
			l_track[i].na += na;
			rot_area(at, na, x, y, &head);
		}
		if (nt +l_track[i].nt >= MAXTEXT)
		{
			say_error("too many textlines !");
			return(TRUE);
		}
		if (nt)
		{
			if (fread(tt, sizeof(TextTyp), nt, fp) != nt)
			{
				say_error("text-data read error");
				return(TRUE);
			}
			l_track[i].nt += nt;
			rot_text(tt, nt, x, y, &head);
		}
	}
	return(FALSE);
}

/******************************************

		Pins lesen

******************************************/
int read_dots(fp)
FILE	*fp;
{
	register	DotTyp	*dt;
	register	EleTyp	*et;

	if (fread(&d_data.n, sizeof(int), 1, fp) != 1)
	{
		d_data.n = 0;
		say_error("pin-head read error");
		return(TRUE);
	}
	dt = d_data.d;
	if (d_data.n)
		if (fread(dt, sizeof(DotTyp), d_data.n, fp) != d_data.n)
		{
			say_error("pin-data read error");
			return(TRUE);
		}
	if (fread(&element.n, sizeof(int), 1, fp) != 1)
	{
		element.n = 0;
		say_error("element-head read error");
		return(TRUE);
	}
	et = element.e;
	if (element.n)
		if (fread(et, sizeof(EleTyp), element.n, fp) != element.n)
		{
			say_error("element-data read error");
			return(TRUE);
		}
	return(FALSE);
}

/******************************************

		Layers lesen

******************************************/
int read_layer(fp)
FILE	*fp;
{
	register	LineTyp	*lt;
	register	AreaTyp	*at;
	register	TextTyp	*tt;
	register	int		i, j;

	for (i = 0; i < MAXLAYER; i++)
	{
		if (fread(&l_track[i].n, sizeof(int), 1, fp) != 1 ||
			fread(&l_track[i].na, sizeof(int), 1, fp) != 1 ||
			fread(&l_track[i].nt, sizeof(int), 1, fp) != 1)
		{
			for (j = i; j < MAXLAYER; j++)
				l_track[j].n = l_track[j].na = l_track[j].nt = 0;
			say_error("layer-head read error");
			return(TRUE);
		}
		lt = l_track[i].l;
		at = l_track[i].a;
		tt = l_track[i].t;
		if (l_track[i].n)
			if (fread(lt, sizeof(LineTyp), l_track[i].n, fp) != l_track[i].n)
			{
				for (j = i; j < MAXLAYER; j++)
					l_track[j].n = l_track[j].na = l_track[j].nt = 0;
				say_error("line-data read error");
				return(TRUE);
			}
		if (l_track[i].na)
			if (fread(at, sizeof(AreaTyp), l_track[i].na, fp) != l_track[i].na)
			{
				for (j = i; j < MAXLAYER; j++)
					l_track[j].n = l_track[j].na = l_track[j].nt = 0;
				say_error("area-data read error");
				return(TRUE);
			}
		if (l_track[i].nt)
			if (fread(tt, sizeof(TextTyp), l_track[i].nt, fp) != l_track[i].nt)
			{
				for (j = i; j < MAXLAYER; j++)
					l_track[j].n = l_track[j].na = l_track[j].nt = 0;
				say_error("text-data read error");
				return(TRUE);
			}
	}
	return(FALSE);
}

/******************************************

		header schreiben

******************************************/
int wrt_tehead(fp)
FILE	*fp;
{
	static	int	magic = TEMAGIC;

	if (fwrite(&magic, sizeof(int), 1, fp) != 1 || fwrite(&head, sizeof(Header), 1, fp) != 1)
	{
		say_error("head write error");
		return(TRUE);
	}
	else
		return(FALSE);
}

/******************************************

		header schreiben

******************************************/
int wrt_head(fp)
FILE	*fp;
{
	static	int	magic = MAGIC;

	if (fwrite(&magic, sizeof(int), 1, fp) != 1 || fwrite(&head, sizeof(Header), 1, fp) != 1)
	{
		say_error("head write error");
		return(TRUE);
	}
	else
		return(FALSE);
}

/******************************************

		Pins schreiben

******************************************/
int wrt_bldots(fp)
FILE	*fp;
{
	register	DotTyp	*dt;
	register	EleTyp	*et;
	register	int		i;
				int		count;
				long	pos;

	count = 0;
	pos = ftell(fp);
	if (fwrite(&count, sizeof(int), 1, fp) != 1)
	{
		say_error("pin-head write error");
		return(TRUE);
	}
	if (d_data.on)
	{
		dt = d_data.d;
		for (i = 0; i < d_data.n; i++, dt++)
		{
			if (D_IN_BLK(dt))
			{
				if (fwrite(dt, sizeof(DotTyp), 1, fp) != 1)
				{
					say_error("pin-data write error");
					return(TRUE);
				}
				else
					count++;
			}
		}
	}
	fseek(fp, pos, SEEK_SET);
	if (fwrite(&count, sizeof(int), 1, fp) != 1)
	{
		say_error("pin-head write error");
		return(TRUE);
	}
	fseek(fp, 0L, SEEK_END);
	count = 0;
	pos = ftell(fp);
	if (fwrite(&count, sizeof(int), 1, fp) != 1)
	{
		say_error("element-head write error");
		return(TRUE);
	}
	if (element.on)
	{
		et = element.e;
		for (i = 0; i < element.n; i++, et++)
		{
			if (LAT_IN_BLK(et))
			{
				if (fwrite(et, sizeof(EleTyp), 1, fp) != 1)
				{
					say_error("element-data write error");
					return(TRUE);
				}
				else
					count++;
			}
		}
	}
	fseek(fp, pos, SEEK_SET);
	if (fwrite(&count, sizeof(int), 1, fp) != 1)
	{
		say_error("element-head write error");
		return(TRUE);
	}
	fseek(fp, 0L, SEEK_END);
	return(FALSE);
}

/******************************************

		Pins schreiben

******************************************/
int wrt_dots(fp)
FILE	*fp;
{
	register	DotTyp	*dt;
	register	EleTyp	*et;

	if (fwrite(&d_data.n, sizeof(int), 1, fp) != 1)
	{
		say_error("pin-head write error");
		return(TRUE);
	}
	dt = d_data.d;
	if (d_data.n)
		if (fwrite(dt, sizeof(DotTyp), d_data.n, fp) != d_data.n)
		{
			say_error("pin-data write error");
			return(TRUE);
		}
	if (fwrite(&element.n, sizeof(int), 1, fp) != 1)
	{
		say_error("element-head write error");
		return(TRUE);
	}
	et = element.e;
	if (element.n)
		if (fwrite(et, sizeof(EleTyp), element.n, fp) != element.n)
		{
			say_error("element-data write error");
			return(TRUE);
		}
	return(FALSE);
}

/******************************************

		Layers schreiben

******************************************/
int wrt_bllayer(fp)
FILE	*fp;
{
	register	LineTyp	*lt;
	register	AreaTyp	*at;
	register	TextTyp	*tt;
	register	int		i, j;
				int		countl, counta, countt;
				long	pos;

	for (i = 0; i < MAXLAYER; i++)
	{
		pos = ftell(fp);
		countl = counta = countt = 0;
		if (fwrite(&countl, sizeof(int), 1, fp) != 1 ||
			fwrite(&counta, sizeof(int), 1, fp) != 1 ||
			fwrite(&countt, sizeof(int), 1, fp) != 1)
		{
			say_error("layer-head write error");
			return(TRUE);
		}
		if (l_track[i].on)
		{
			lt = l_track[i].l;
			at = l_track[i].a;
			tt = l_track[i].t;
			for (j = 0; j < l_track[i].n; j++, lt++)
			{
				if (LAT_IN_BLK(lt))
				{
					if (fwrite(lt, sizeof(LineTyp), 1, fp) != 1)
					{
						say_error("line-data write error");
						return(TRUE);
					}
					else
						countl++;
				}
			}
			for (j = 0; j < l_track[i].na; j++, at++)
				if(LAT_IN_BLK(at))
				{
					if (fwrite(at, sizeof(AreaTyp), 1, fp) != 1)
					{
						say_error("area-data write error");
						return(TRUE);
					}
					else
						counta++;
				}
			for (j = 0; j < l_track[i].nt; j++, tt++)
				if (LAT_IN_BLK(tt))
				{
					if (fwrite(tt, sizeof(TextTyp), 1, fp) != 1)
					{
						say_error("text-data write error");
						return(TRUE);
					}
					else
						countt++;
				}
		}
		fseek(fp, pos, SEEK_SET);
		if (fwrite(&countl, sizeof(int), 1, fp) != 1 ||
			fwrite(&counta, sizeof(int), 1, fp) != 1 ||
			fwrite(&countt, sizeof(int), 1, fp) != 1)
		{
			say_error("layer-head write error");
			return(TRUE);
		}
		fseek(fp, 0L, SEEK_END);
	}
	return(FALSE);
}

/******************************************

		Layers schreiben

******************************************/
int wrt_telayer(fp)
FILE	*fp;
{
	register	LineTyp	*lt;
	register	int		i, j;
				int		countl;
				long	pos;

	i = info.plane;
	pos = ftell(fp);
	countl = 0;
	if (fwrite(&countl, sizeof(int), 1, fp) != 1)
	{
		say_error("layer-head write error");
		return(TRUE);
	}
	lt = l_track[i].l;
	for (j = 0; j < l_track[i].n; j++, lt++)
	{
		if (LAT_IN_BLK(lt))
		{
			if (fwrite(lt, sizeof(LineTyp), 1, fp) != 1)
			{
				say_error("line-data write error");
				return(TRUE);
			}
			else
				countl++;
		}
	}
	fseek(fp, pos, SEEK_SET);
	if (fwrite(&countl, sizeof(int), 1, fp) != 1)
	{
		say_error("layer-head write error");
		return(TRUE);
	}
	fseek(fp, 0L, SEEK_END);
	return(FALSE);
}

/******************************************

		Layers schreiben

******************************************/
int wrt_layer(fp)
FILE	*fp;
{
	register	LineTyp	*lt;
	register	AreaTyp	*at;
	register	TextTyp	*tt;
	register	int		i;

	for (i = 0; i < MAXLAYER; i++)
	{
		if (fwrite(&l_track[i].n, sizeof(int), 1, fp) != 1 ||
			fwrite(&l_track[i].na, sizeof(int), 1, fp) != 1 ||
			fwrite(&l_track[i].nt, sizeof(int), 1, fp) != 1)
		{
			say_error("layer-head write error");
			return(TRUE);
		}
		lt = l_track[i].l;
		at = l_track[i].a;
		tt = l_track[i].t;
		if (l_track[i].n)
			if (fwrite(lt, sizeof(LineTyp), l_track[i].n, fp) != l_track[i].n)
			{
				say_error("line-data write error");
				return(TRUE);
			}
		if (l_track[i].na)
			if (fwrite(at, sizeof(AreaTyp), l_track[i].na, fp) != l_track[i].na)
			{
				say_error("area-data write error");
				return(TRUE);
			}
		if (l_track[i].nt)
			if (fwrite(tt, sizeof(TextTyp), l_track[i].nt, fp) != l_track[i].nt)
			{
				say_error("text-data write error");
				return(TRUE);
			}
	}
	return(FALSE);
}

/******************************************

		Header Daten setzen

******************************************/
void set_blhead()
{
	register	LineTyp		*lt;
	register	DotTyp		*dt;
	register	AreaTyp		*at;
	register	TextTyp		*tt;
	register	EleTyp		*et;
	register	int			i, j;
				int			n;

	act_coord(&head.offx, &head.offy);
	head.minx = XMAX;
	head.miny = YMAX;
	head.maxx = 0;
	head.maxy = 0;
	dt = d_data.d;
	for (i = 0; i < d_data.n; i++, dt++)
	{
		if (D_IN_BLK(dt))
		{
			D_MM_HEAD(dt);
		}
	}
	et = element.e;
	for (i = 0; i < element.n; i++, et++)
	{
		if (LAT_IN_BLK(et))
		{
			LAT_MM_HEAD(et);
		}
	}
	for (j = 0; j < MAXLAYER; j++)
	{
		n = l_track[j].n;
		lt = l_track[j].l;
		for (i = 0; i < n; i++, lt++)
		{
			if (LAT_IN_BLK(lt))
			{
				LAT_MM_HEAD(lt);
			}
		}
		n = l_track[j].na;
		at = l_track[j].a;
		for (i = 0; i < n; i++, at++)
		{
			if (LAT_IN_BLK(at))
			{
				LAT_MM_HEAD(at);
			}
		}
		n = l_track[j].nt;
		tt = l_track[j].t;
		for (i = 0; i < n; i++, tt++)
		{
			if (LAT_IN_BLK(tt))
			{
				LAT_MM_HEAD(tt);
			}
		}
	}
} 

/******************************************

		Header Daten setzen

******************************************/
void set_tehead()
{
	register	LineTyp		*lt;
	register	int			i, j;
				int			n;

	head.minx = XMAX;
	head.miny = YMAX;
	head.maxx = 0;
	head.maxy = 0;
	j = info.plane;
	n = l_track[j].n;
	lt = l_track[j].l;
	for (i = 0; i < n; i++, lt++)
	{
		if (LAT_IN_BLK(lt))
		{
			LAT_MM_HEAD(lt);
		}
	}
	head.offx = head.minx;
	head.offy = MIN(act_block.y1, act_block.y2);
} 

/******************************************

		Header Daten setzen

******************************************/
void set_header()
{
	register	LineTyp		*lt;
	register	DotTyp		*dt;
	register	AreaTyp		*at;
	register	TextTyp		*tt;
	register	EleTyp		*et;
	register	int			i, j;
				int			n;

	act_coord(&head.offx, &head.offy);
	head.minx = XMAX;
	head.miny = YMAX;
	head.maxx = 0;
	head.maxy = 0;
	dt = d_data.d;
	for (i = 0; i < d_data.n; i++, dt++)
	{
		D_MM_HEAD(dt);
	}
	et = element.e;
	for (i = 0; i < element.n; i++, et++)
	{
		LAT_MM_HEAD(et);
	}
	for (j = 0; j < MAXLAYER; j++)
	{
		n = l_track[j].n;
		lt = l_track[j].l;
		for (i = 0; i < n; i++, lt++)
		{
			LAT_MM_HEAD(lt);
		}
		n = l_track[j].na;
		at = l_track[j].a;
		for (i = 0; i < n; i++, at++)
		{
			LAT_MM_HEAD(at);
		}
		n = l_track[j].nt;
		tt = l_track[j].t;
		for (i = 0; i < n; i++, tt++)
		{
			LAT_MM_HEAD(tt);
		}
	}
} 

/******************************************

		ok holen

******************************************/
int get_ok(s)
char	*s;
{
	char	s1[80];
	long	c;

	o_clrstat();
	sprintf(s1, " %s <y,n> ", s);
	o_status(s);
	do
	{
		while (!Cconis());
		c = Cnecin() & 0xff;
	} while (c != 'y' && c != 'Y' && c != 'n' && c != 'N');
	o_clrstat();
	return((c == 'y' || c == 'Y') ? TRUE : FALSE);
}

/******************************************

		Block speichern

******************************************/
int save_block(fptr)
char *fptr;
{
	FILE	*fp;

	if (Fattrib(fptr, 0, 0) >= 0)
		if (!get_ok("file exists, override ? "))
			return(TRUE);
	if ((fp = fopen(fptr, "wb")) == NULL)
	{
		say_error("write-open error");
		return(TRUE);
	}
	set_blhead();
	if (!wrt_head(fp))
		if (!wrt_bldots(fp))
			wrt_bllayer(fp);
	fclose(fp);
	return(FALSE);
}

/******************************************

		Block speichern

******************************************/
int save_text(fptr)
char *fptr;
{
	FILE	*fp;

	if (Fattrib(fptr, 0, 0) >= 0)
		if (!get_ok("file exists, override ? "))
			return(TRUE);
	if ((fp = fopen(fptr, "wb")) == NULL)
	{
		say_error("write-open error");
		return(TRUE);
	}
	set_tehead();
	if (!wrt_tehead(fp))
			wrt_telayer(fp);
	fclose(fp);
	return(FALSE);
}

/******************************************

		Layout speichern

******************************************/
int save_lay(fptr, ask)
char	*fptr;
int		ask;
{
	FILE	*fp;
	char	*fname;

	if (fptr == NULL)
	{
		if ((fname = get_fname()) == NULL)
			return(TRUE);
	}
	else
		fname = fptr;
	if (ask && (Fattrib(fname, 0, 0) >= 0))
		if (!get_ok("file exists, override ? "))
			return(TRUE);
	if ((fp = fopen(fname, "wb")) == NULL)
	{
		say_error("write-open error");
		return(TRUE);
	}
	set_header();
	if (!wrt_head(fp))
		if (!wrt_dots(fp))
			if (!wrt_layer(fp))
				info.changed = FALSE;
	fclose(fp);
	return(FALSE);
}

/******************************************

		Layout laden

******************************************/
void load_lay(fptr)
char *fptr;
{
	FILE	*fp;
	char	*fname;

	if (info.changed)
		if (get_ok("save old data first ?"))
			save_lay(((filename[0]) ? filename : NULL), TRUE);
	if (fptr == NULL)
	{
		if ((fname = get_fname()) == NULL)
			return;
	}
	else
		fname = fptr;
	if (Fattrib(fname, 0, 0) < 0)
	{
		say_error("file not found ! ");
		return;
	}
	if ((fp = fopen(fname, "rb")) == NULL)
	{
		say_error("read-open error");
		return;
	}
	if (!read_head(fp))
		if (!read_dots(fp))
			if (!read_layer(fp))
				info.changed = FALSE;
	fclose(fp);
	strcpy(filename, fname);
}

/******************************************

		Layout mischen

******************************************/
void merge_lay(fptr)
char *fptr;
{
	FILE	*fp;
	char	*fname;
	int		x, y;

	if (fptr == NULL)
	{
		if ((fname = get_fname()) == NULL)
			return;
	}
	else
		fname = fptr;
	if (Fattrib(fname, 0, 0) < 0)
	{
		say_error("file not found ! ");
		return;
	}
	if ((fp = fopen(fname, "rb")) == NULL)
	{
		say_error("read-open error");
		return;
	}
	if (!read_head(fp))
		if (!mbl_head())
		{
			act_coord(&x, &y);
			if (!chk_head(x, y))
			{
				info.changed = TRUE;
				if (!merg_dots(fp, x, y))
					merg_layer(fp, x, y);
			}
		}
	fclose(fp);
}

/******************************************

		Textzeile aus file lesen, Leerzeilen, Kommentare ueberlesen

******************************************/
int read_line(s, fp)
char	s[];
FILE	*fp;
{
	register	int	ch, i, flag;
	
	flag = FALSE;
	i = 0;
	while ((ch = getc(fp)) != EOF || i == 80)
	{
		switch(ch)
		{
			case	'\n' :
			case	'\r' : s[i] = '\0';
						   if (i && flag) return(FALSE);
						   i = 0;
						   break;
			case	'#'	 : s[i] = 0;
						   while((ch = getc(fp)) != EOF &&
						   		  ch != '\r' && ch != '\n');
						   if (i && flag) return(FALSE);
						   i = 0;
						   break;
			case	' '  :
			case	'\t' : s[i++] = ch;
						   break;
			default		 : s[i++] = ch;
						   flag = TRUE;
						   break;	   
		}
	}
	s[i] = '\0';
	return((i && flag) ? FALSE : TRUE);
}

/******************************************

		Pinbezeichnung laden

******************************************/
void load_pinname(fname, lib)
char	*fname;
int		lib;
{
	register	int		i, j;
	register	DotTyp	*dt;
				char	*fn;
				char	s[81], s1[81];
				int		x0, y0, x1, y1, x, y, n, pins;
				FILE	*fp;
				long	pos;

	do
	{
		if (lib)
		{
			pos = count_ele(fname, &n);
			switch(n)
			{
				case	-1	:	say_error("no matching file"); return;
				case	0	:	if (op_ar("PINLIB", PINFILE))
									return;
								fseek(ar_fp, pos, SEEK_SET);
								break;
				case	1	:	say_error("too many matching files"); return;
				case	2	:	say_error("no library file"); return;
			}
			fp = ar_fp;
		}
		else
		{
			fn = count_file(fname, &n);
			switch(n)
			{
				case	-1	:	say_error("no matching file"); return;
				case	1	:	say_error("too many matching files"); return;
			}
			if ((fp = fopen(fn, "r")) == NULL)
			{
				say_error("can't open file...");
				return;
			}
		}
		if (read_line(s, fp) ||
			sscanf(s, "%d %d %d %d %d %d", 
					  &head.offx, &head.offy,
					  &head.minx, &head.miny,
					  &head.maxx, &head.maxy) != 6)
		{
			say_error("illegal format...");
			fclose(fp);
			return;
		}
		if (mbl_head())
			return;
		act_coord(&x0, &y0);
		if (read_line(s, fp) ||
			(pins = atoi(s)) <= 0)
		{
			say_error("illegal format...");
			fclose(fp);
			return;
		}
		for (i = 0; i < pins; i++)
		{
			if (read_line(s, fp) ||
				sscanf(s, "%d %d %s", &x, &y, s1) != 3)
			{
				say_error("illegal format...");
				fclose(fp);
				return;
			}
			x -= head.offx;
			y -= head.offy;
			switch(info.rot)
			{
				case	1 :	x1 = x0 -y;
							y1 = y0 +x;
							break;
				case	2 :	x1 = x0 -x;
							y1 = y0 -y;
							break;
				case	3 :	x1 = x0 +y;
							y1 = y0 -x;
							break;
				default   :	x1 = x0 +x;
							y1 = y0 +y;
							break;
			}
			dt = d_data.d;
			for (j = 0; j < d_data.n; j++, dt++)
				if (x1 == dt->x && y1 == dt->y) 
				{
					strncpy(dt->name, s1, PNAMLEN-1);
					dt->name[PNAMLEN-1] = '\0';
					break;
				}
			if (j >= d_data.n)
			{
				say_error("pins don't match...");
				fclose(fp);
				break;
			}
		}
		fclose(fp);
		info.changed = TRUE;
	} while(TRUE);
}

/******************************************

		Filenamen lesen

******************************************/
char *get_fname()
{
	static	char	s[81];

	strcpy(s, "");
	if (!get_instr("file: ", s))
		return(NULL);
	else
		return(s);
}
