/*****************************************************

		Platinen Layout fr ATARI ST in TURBO C
					Thomas Nau (c) 1990
	license: GNU GPL 2+ (see ../COPYING)

*****************************************************/

/* Standart INCLUDE files */

#include <stdio.h>
#include <stdlib.h>
#include <linea.h>
#include <tos.h>
#include <ext.h>
#include <string.h>
#include <lp.h>

#define L_MAIN
#define	USAGE	fprintf(stderr, "la [file]\n"), exit(1)

#include "l_incl.h"     /* alle anderen INCLUDE Files */

static char lpname_buf[LP_NAMELEN+1];
/******************************************

		initialisiert Variable

******************************************/
void init()
{
	register	int	i;

	linea_init();
	o_scrinit(Physbase(), (void *) Fonts->font[1]->fnt_dta);

	for (i = 0; i < MAXLAYER; i++)
	{
		l_track[i].n = 0;
		l_track[i].na = 0;
		l_track[i].nt = 0;
		l_track[i].on = TRUE;
		l_track[i].a = (AreaTyp *) calloc(MAXAREA, sizeof(AreaTyp));
		l_track[i].l = (LineTyp *) calloc(MAXLINES, sizeof(LineTyp));
		l_track[i].t = (TextTyp *) calloc(MAXTEXT, sizeof(TextTyp));
		if (!l_track[i].a || !l_track[i].l || !l_track[i].t)
			fprintf(stderr, "out of memory error\n"), exit(1);
	}
	element.e = (EleTyp *) calloc(MAXELEM, sizeof(EleTyp));
	element.n = 0;
	d_data.d = (DotTyp *) calloc(MAXDOTS, sizeof(DotTyp));
	d_data.on = TRUE;
	d_data.n = 0;
	l_stack.l = (LineTyp *) calloc(MAXSTACK, sizeof(LineTyp));
	l_stack.n = 0;
	l_stack.on = FALSE;
	if (!d_data.d || !l_stack.l || !element.e)
		fprintf(stderr, "out of memory error\n"), exit(1);

	grid[0] = 1;
	grid[1] = 2;
	grid[2] = 5;
	grid[3] = 10;
	grid[4] = 20;
	for (i = 0; i < LINETYPES; i++)
	{
		linewidth[i] = i+1;
		sl_width[i] = TAN_CONST/2.0 *(i+1);
	}
	dotwidth[0] = 4;
	dotwidth[1] = 5;
	dotwidth[2] = 6;
	dotwidth[3] = 8;
	dotwidth[4] = 10;
	for (i = 0; i < DOTTYPES; i++)
		sd_width[i] = TAN_CONST/2.0 *dotwidth[i];
	zoom[0] = 1;
	zoom[1] = 2;
	zoom[2] = 4;
	zoom[3] = 8;

	act_line.on = FALSE;
	act_block.on = FALSE;

	info.maxx = XSCREEN;
	info.maxy = YSCREEN;
	info.zoom = ZOOMDEF;
	info.plane = info.cmplane = 0;
	info.offx = info.offy = 0;
	info.dl = STARTDOT;
	info.ll = STARTLINE;
	info.grid = DEFGRID;
	info.cur = 1;
	info.rot = 0;
	info.changed = FALSE;
	info.sorted = FALSE;
	info.ctrl = FALSE;
	element.on = TRUE;
	info.stline = TRUE;
	info.mir = FALSE;
	set_gfac();
	set_lstr();

	prt.zoom = 1.0;
	prt.lzoom = 1.0;
	prt.dzoom = 1.0;
	prt.deldot = FALSE;
	prt.name = lpname(lpname_buf);
	
	mod_name[0] = '\0';

	cursor.on = FALSE;

	init_dl();
	init_keys();
}

/******************************************

      Layer string setzen

******************************************/
void set_lstr()
{
	register	int		i;

	l_string[0] = (d_data.on ? '0' : ' ');
	for (i = 0; i < MAXLAYER; i++)
		l_string[i+1] = (l_track[i].on ? (char) (i+49) : ' ');
	l_string[i+1] = '\0';
}

/******************************************

      g-Faktor setzen

******************************************/
void set_gfac()
{
	info.gfac = grid[info.grid] *zoom[info.zoom];
}

/******************************************

      behandelt Cursortasten

******************************************/
int do_curkeys()
{
	long	ch, scan;
	char	ch1;

	ch = Cnecin();
	scan = ch >> 16;
	ch1 = (char) (ch & 0xff);
	ch &= 0xff;
	if (!ch)				/* Funktionstasten */
	{
		switch((int) scan)
		{
/* up */	case	0x0048	:	cursor_move(0, -info.cur); break;
/* dn */	case	0x0050	:	cursor_move(0,  info.cur); break;
/* le */	case	0x004b	:	cursor_move(-info.cur, 0); break;
/* ri */	case	0x004d	:	cursor_move(info.cur,  0); break;
			default			:	return(1);
		}
	}
	else
		switch((int) ch1)
		{
/* ^g */	case	0x07	:	set_grid(); break;
/* ^m */	case	0x0d	:	return(-1);
/* 1 */		case	'1'		:
/* 2 */		case	'2'		:
/* 3 */		case	'3'		:
/* 4 */		case	'4'		:
/* 5 */		case	'5'		:
/* 6 */		case	'6'		:
/* 7 */		case	'7'		:
/* 8 */		case	'8'		:
/* 9 */		case	'9'		:
/* 0 */		case	'0'		:	set_cur((int) ch1); break;
			default			:	return(1);
		}
	return(0);
}

/******************************************

		Raster setzen

******************************************/
void set_grid()
{
	if (++info.grid >= GRIDMAX) info.grid = 0;
	Vdiesc->gcurx = (Vdiesc->gcurx /info.gfac) *info.gfac;
	Vdiesc->gcury = (Vdiesc->gcury /info.gfac) *info.gfac;
	set_gfac();
}

/******************************************

		Raster setzen

******************************************/
void set_cur(val)
int val;
{
	val -= '0';
	if (val)
		info.cur = val;
	else
		info.cur = 10;
}

/******************************************

      Tastaturabfrage

******************************************/
int do_keys()
{
	long	ch, scan;
	int		x, y, i, found;
	char	ch1;
	DotTyp	*dt;

	ch = Cnecin();
	scan = ch >> 16;
	ch1 = (char) (ch & 0xff);
	ch &= 0xff;
	if (!ch)				/* Funktionstasten */
	{
		switch((int) scan)
		{
/* up */	case	0x0048	:	cursor_move(0, -info.cur); break;
/* dn */	case	0x0050	:	cursor_move(0,  info.cur); break;
/* le */	case	0x004b	:	cursor_move(-info.cur, 0); break;
/* ri */	case	0x004d	:	cursor_move(info.cur,  0); break;
/* f1 */	case	0x003b	:	if (d_data.on)
								{
									set_dot(); 
									info.changed = TRUE;
								}
								else
									say_error("pin-layer's switched off...");
								break;
/* F1 */	case	0x0054	:	if (d_data.on)
								{
									del_dot(); 
									info.changed = TRUE;
								}
								else
									say_error("pin-layer's switched off...");
								break;
/* f2 */	case	0x003c	:	cursor_off();
								act_block.on = FALSE;
								if (!act_line.on)
								{
									act_coord(&act_line.x1, &act_line.y1);
									act_line.x2 = act_line.x1;
									act_line.y2 = act_line.y1;
									act_line.on = TRUE;
								}
								else
								{
									info.changed = TRUE;
									info.sorted = FALSE;
									set_track();
									act_line.x1 = act_line.x2;
									act_line.y1 = act_line.y2;
								}
								cursor_on();
								break;
/* F2 */	case	0x0055	:	del_track(); 
								info.changed = TRUE;
								info.sorted = FALSE;
								break;
/* f3 */	case	0x003d	:	cursor_off();
								act_block.on = FALSE;
								act_line.on = FALSE;
								cursor_on();
								break;
/* f4 */	case	0x003e	:	cursor_off();
								act_line.on = FALSE;
								if (act_block.on == 0 || act_block.on == 2)
								{
									act_coord(&act_block.x1, &act_block.y1);
									act_block.x2 = act_block.x1;
									act_block.y2 = act_block.y1;
									act_block.on = 1;
								}
								else
									if (act_block.on == 1)
									{
										act_coord(&act_block.x2, &act_block.y2);
										if (act_block.x1 > act_block.x2)
										{
											x = act_block.x1;
											act_block.x1 = act_block.x2;
											act_block.x2 = x;
										}
										if (act_block.y1 > act_block.y2)
										{
											y = act_block.y1;
											act_block.y1 = act_block.y2;
											act_block.y2 = y;
										}
										act_block.on = 2;
									}
								cursor_on();
								break;
/* F4 */	case	0x0057	:	del_area();
								info.sorted = FALSE;
								info.changed = TRUE;
								break;
/* f5 */	case	0x003f	:	if (info.zoom > 0)
								{
									act_coord(&x, &y);
									info.zoom--;
									set_gfac();
									scr_center(x, y);
									update_scr();
								}
								break;
/* F5 */	case	0x0058	:	if (info.zoom < ZOOMMAX-1)
								{
									act_coord(&x, &y);
									info.zoom++;
									set_gfac();
									scr_center(x, y);
									update_scr();
								}
								break;
/* f6 */	case	0x0040	:	act_coord(&x, &y);
								scr_center(x, y);
								update_scr();
								break;
/* f7 */	case	0x0041	:	update_scr();
								break;
/* f8 */	case	0x0042	:	save_lay(((filename[0]) ? filename : NULL), TRUE);
								update_scr();
								break;
/* F8 */	case	0x005b	:	load_lay(NULL);
								update_scr();
								info.sorted = FALSE;
								break;
/* f9 */	case	0x0043	:	cursor_off();
								if (cm_block(FALSE))
								{
									info.changed = TRUE;
									info.sorted = FALSE;
								}
								cursor_on();
								break;
/* F9 */	case	0x005c	:	cursor_off();
								if (cm_block(TRUE))
								{
									info.changed = TRUE;
									act_block.on = FALSE;
									info.sorted = FALSE;
								}
								cursor_on();
								break;
/* f10 */	case	0x0044	:	cursor_off();
								copy_stack();
								info.changed = TRUE;
								info.sorted = FALSE;
								cursor_on();
								break;
			default			:	break;
		}
	}
	else
	{
		switch((int) ch1)
		{
/* ^b */	case	0x02	:	l_stack.n = 0;
								l_stack.on = TRUE;
								act_coord(&info.sx, &info.sy);
								break;
/* C */		case	0x43	:	cursor_off();
								if (cm_plane(FALSE))
								{
									info.changed = TRUE;
									info.sorted = FALSE;
								}
								cursor_on();
								break;
/* c */		case	0x63	:	info.ctrl = !info.ctrl;
								update_scr();
								break;
/* ^d */	case	0x04	:	if (act_block.on == 2)
								{
									cursor_off();
									info.changed = TRUE;
									info.sorted = FALSE;
									clr_block();
									act_block.on = FALSE;
									cursor_on();
								}
								break;
/* D */		case	0x44	:	page_down();
								break;
/* ^e */	case	0x05	:	l_stack.on = FALSE;
								break;
/* E */		case	0x45	:	element.on = element.on ? FALSE : TRUE;
								if (element.n)
									update_scr();
								break;
/* ^f */	case	0x06	:	if (act_block.on == 2)
								{
									cursor_off();
									info.changed = TRUE;
									set_area();
									act_block.on = FALSE;
									cursor_on();
								}
								break;
/* f */		case	0x66	:	if (d_data.on)
								{
									act_coord(&x, &y);
									cursor_off();
									dt = d_data.d;
									found = FALSE;
									for (i = 0; i < d_data.n && !found; i++, dt++)
										if (!dt->used && dt->x == x && dt->y == y)
										{
											rtr_connect(i, "searching...");
											found = TRUE;
											info.changed = TRUE;
											draw_found_dots();
										}
									cursor_on();
								}
								break;
/* F */		case	0x46	:	if (d_data.on)
								{
									act_coord(&x, &y);
									cursor_off();
									dt = d_data.d;
									found = FALSE;
									for (i = 0; i < d_data.n && !found; i++, dt++)
										if (dt->x == x && dt->y == y)
										{
											del_used();
											rtr_connect(i, "searching...");
											found = TRUE;
											draw_found_dots();
										}
									cursor_on();
								}
								break;
/* ^g */	case	0x07	:	set_grid();
								break;
/* ^l */	case	0x0c	:	i = info.plane;
								do
								{
									if (++info.plane >= MAXLAYER)
										info.plane = 0;
								} while (!l_track[info.plane].on && i != info.plane);
								if (i == info.plane)
									say_error("all other layers are switched off...");
								break;
/* l */		case	0x6c	:	if (++info.cmplane >= MAXLAYER)
									info.cmplane = 0;
								break;
/* L */		case	0x4c	:	page_left();
								break;
/* ^m */	case	0x0d	:	merge_lay(NULL);
								info.sorted = FALSE;
								update_scr();
								break;
/* m */		case	0x6d	:	info.mir = info.mir ? FALSE : TRUE;
								break;
/* M */		case	0x4d	:	cursor_off();
								if (cm_plane(TRUE))
								{
									info.changed = TRUE;
									info.sorted = FALSE;
									act_block.on = FALSE;
								}
								cursor_on();
								break;
/* ^n */	case	0x0e	:	if (get_ok("delete data ?"))
								{
									for (i = 0; i < MAXLAYER; i++)
									{
										l_track[i].n = l_track[i].na = l_track[i].nt = 0;
									}
									element.n = 0;
									d_data.n = 0;
									filename[0] = '\0';
									info.sorted = FALSE;
									info.changed = FALSE;
								}
								update_scr();
								break;
/* N */		case	0x4e	:	set_pinname();
								break;
/* ^o */	case	0x0f	:	act_coord(&info.sx, &info.sy);
								break;
/* ^p */	case	0x10	:	if (++info.dl >= DOTTYPES) info.dl = 0;
								break;
/* p */		case	0x70	:	chg_dsize();
								info.changed = TRUE;
								break;
/* P */		case	0x50	:	chg_dbsize();
								info.changed = TRUE;
								break;
/* ^r */	case	0x12	:	if (++info.rot >= 4)
									info.rot = 0;
								break;
/* R */		case	0x52	:	page_right();
								break;
/* S */		case	0x53	:	if ((info.stline = (info.stline ? FALSE : TRUE)) == FALSE)
									o_clrstat();
								break;
/* T */		case	0x54	:	del_text();
								info.sorted = FALSE;
								info.changed = TRUE;
								break;
/* ^u */	case	0x15	:	cursor_off();
								update_dir();
								info.sorted = FALSE;
								cursor_on();
								break;
/* U */		case	0x55	:	page_up();
								break;
/* u */		case	0x75	:	del_used();
								update_scr();
								break;
/* ^w */	case	0x17	:	if (++info.ll >= LINETYPES) info.ll = 0;
								break;
/* W */	case	0x57	:	chg_bsize();
								info.changed = TRUE;
								break;
/* w */	case	0x77	:	chg_size();
								info.changed = TRUE;
								break;
			case	'='		:	d_data.on = !d_data.on;
								set_lstr();
								update_scr();
								break;
			case	'!'		:	i = 0;
			case	'\"'	:	if ((int) ch1 == '\"') i = 1;
			case	'#':
			case	''		:	if (((int) ch1 == '') || ((int) ch1 == '#')) i = 2;
								if (i < MAXLAYER)
								{
									l_track[i].on = !l_track[i].on;
									set_lstr();
									update_scr();
								}
								break;
/* + */		case	'+'		:	l_stack.on = TRUE;
								break;
/* - */		case	'-'		:	if (--l_stack.n < 0)
									l_stack.n++;
								break;
/* 1 */		case	'1'		:
/* 2 */		case	'2'		:
/* 3 */		case	'3'		:
/* 4 */		case	'4'		:
/* 5 */		case	'5'		:
/* 6 */		case	'6'		:
/* 7 */		case	'7'		:
/* 8 */		case	'8'		:
/* 9 */		case	'9'		:
/* 0 */		case	'0'		:	set_cur((int) ch1); break;
/* : */		case	':'		:	cursor_off();
								o_clrstat();
								if (do_command())
									return(TRUE);
								cursor_on();
								break;
			default			:	break;
		}
	}
	status();
	return(FALSE);
}

/******************************************

		Eingabestring holen

******************************************/
int get_instr(os, is)
char	*is, *os;
{
	static		char	s[81];
	register	int		i, off;
				long	ch;

	o_clrstat();
	strcpy(s, os);
	strcat(s, is);
	i = (int) strlen(s);
	off = (int) strlen(os);
	do
	{
		o_status(s);
		while (!Cconis());
		ch = (Cnecin()) & 0xff;
		switch ((char) ch)
		{
			case	13		:	strcpy(is, &s[off]);
								i = (int) strlen(is);
								while (i >= 0 && s[i] == ' ')
									s[i--] = '\0';
								return((int) strlen(is));
			case	27		:	return(0);
			case	'\b'	:	s[--i] = '\0';
								if (i < off) return(0);
								o_clrstat();
								break;
			default			:	s[i] = ch;
								s[++i] = '\0';
								if (i > 80) i--;
								break;
		}
	} while (TRUE);
}

/******************************************

      Kommandoeingabe

******************************************/
int do_command()
{
	static		char	is[81];
				char	*p;

	strcpy(is, ":");
	if (!get_instr("", is))
		return(FALSE);
	p = &is[2];
	switch(is[1])
	{
		case	'!'	:	while (*p && *p == ' ') p++;
						if (*p)
						{
							o_clrscr();
							Cursconf(1, 0);
							shell(p);
							say_error("press any key...");
							hide_mouse();
							Cursconf(0, 0);
							update_scr();
						}
						break;
		case	'c'	:	while (*p && *p == ' ') p++;
						if (*p)
						{
							list_connect(p);
							update_scr();
						}
						break;
		case	'C'	:	while (*p && *p == ' ') p++;
						if (*p)
						{
							list_all_con(p);
							update_scr();
						}
						break;
		case	'd'	:	while (*p && *p == ' ') p++;
						del_element(p);
						break;
		case	'e'	:	while (*p && *p == ' ') p++;
						if (*p)
							load_pinname(p, FALSE);
						break;
		case	'E'	:	while (*p && *p == ' ') p++;
						if (*p)
							load_pinname(p, TRUE);
						break;
		case	'm'	:	while (*p && *p == ' ') p++;
						if (*p)
							merg_file(p);
						info.sorted = FALSE;
						break;
		case	'M'	:	while (*p && *p == ' ') p++;
						if (*p)
							merg_lib(p);
						else
							if (*mod_name)
								merg_lib(mod_name);
						info.sorted = FALSE;
						break;
		case	'n'	:	while (*p && *p == ' ') p++;
						set_element(p);
						break;
		case	'p'	:	if (!act_block.on)
						{
							say_error("no block selected...");
							return(FALSE);
						}
						while (*p && *p == ' ') p++;
						if (*p)
							p_menu(p);
						break;
		case	'q' :	return(TRUE);
		case	'r'	:	while (*p && *p == ' ') p++;
						if (*p)
							read_file(p);
						info.sorted = FALSE;
						break;
		case	'R'	:	while (*p && *p == ' ') p++;
						if (*p)
							read_lib(p);
						info.sorted = FALSE;
						break;
		case	't'	:	while (*p && *p == ' ') p++;
						if (*p)
							set_text(p);
						break;
		case	'T'	:	if (!act_block.on)
						{
							say_error("no block selected...");
							return(FALSE);
						}
						while (*p && *p == ' ') p++;
						if (*p)
							save_text(p);
						break;
		case	'w'	:	while (*p && *p == ' ') p++;
						if (*p)
							save_lay(p, TRUE);
						else
						{
							save_lay(NULL, TRUE);
							update_scr();
						}
						break;
		case	'W'	:	if (!act_block.on)
						{
							say_error("no block selected...");
							return(FALSE);
						}
						while (*p && *p == ' ') p++;
						if (*p)
							save_block(p);
						break;
		default		:	break;
	}
	return(FALSE);
}

/******************************************

      Hauptschleife

******************************************/
void do_it()
{
	int		done = FALSE;

	do
	{
#ifndef ATARI
	idle_until_event();
#endif
		if (Cconis())
			done = do_keys();
		if (cursor.on && cursor_chg())
			cursor_new();
	} while (!done);
}

/******************************************

      main

******************************************/
int main(argc, argv)
int		argc;
char	**argv;
{
	int		ok_flg = FALSE;

	init();
	argv++;
	if (argc > 2) USAGE;
	Cursconf(0, 0);
	o_clrscr();
	cursor_on();
	if (argc == 2)
	{
		strcpy(filename, *argv);
		load_lay(filename);
		update_scr();
	}
	else
		filename[0] = '\0';
	do
	{
		do_it();
		if (info.changed)
		{
			if (get_ok("save old data before exit ?"))
				ok_flg = !(save_lay(((filename[0]) ? filename : NULL), TRUE));
			else
				ok_flg = TRUE;
		}
		else
			ok_flg = TRUE;
	} while (!ok_flg);
	o_clrscr();
	Cursconf(1, 0);
	return(0);
}
