/*****************************************************

		Platinen Layout fr ATARI ST in TURBO C
					Thomas Nau (c) 1990
	license: GNU GPL 2+ (see ../COPYING)

*****************************************************/

/* Standart INCLUDE files */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ext.h>
#include <tos.h>
#include <math.h>

#define L_PINOUT

#include "l_incl.h"     /* alle anderen INCLUDE Files */

/******************************************

		Text ausgeben

******************************************/
void set_text(s)
char *s;
{
	register	TextTyp	*tp;
	register	char	*p;
	register	int		i, j;
				int		x, y, dx, x1, y1, x2, y2;
	unsigned	int		k;
				int		len;

	i = info.plane;
	if (!l_track[i].on)
		return;
	if (l_track[i].nt >= MAXTEXT)
	{
		say_error("too many strings on this layer...");
		return;
	}
	len = (int) strlen(s) +1;
	head.minx = head.offx = head.miny = head.offy = 0;
	head.maxx = BLANKCHAR * len;
	head.maxy = BLANKCHAR;
	if (mbl_head())
		return;
	act_coord(&x, &y);
	tp = l_track[i].t +l_track[i].nt;
	x1 = x2 = tp->x = x;
	y1 = y2 = tp->y = y;
	tp->rot = info.rot;
	s[STRLEN-1] = '\0';
	if ((tp->mir = info.mir) == TRUE)
	{
		for (j = 0; j <= len; j++)
			*(tp->t +j) = *(s -j +len);
		*(tp->t +j) = '\0';
	}
	else
		strcpy(tp->t, s);
	p = tp->t;
	while (*p)
	{
		k = *p;
		if (keys[k].l)
		{
			head = keys[k].h;
			if (chk_head(x, y))
			{
				say_error("text module too large...");
				return;
			}
			dx = keys[k].h.maxx -keys[k].h.minx +2;
		}
		else
			dx = BLANKCHAR;
		switch(info.rot)
		{
			case 0 :	x += dx;
						x2 = x;
						y2 = MAX(y2, (y +keys[k].h.maxy -keys[k].h.miny));
						break;
			case 1 :	y += dx;
						y2 = y;
						x1 = MIN(x1, (x -keys[k].h.maxy +keys[k].h.miny));
						break;
			case 2 :	x -= dx;
						x1 = x;
						y1 = MIN(y1, (y -keys[k].h.maxy +keys[k].h.miny));
						break;
			case 3 :	y -= dx;
						y1 = y;
						x2 = MAX(x2, (x +keys[k].h.maxy -keys[k].h.miny));
						break;
			default:	break;
		}
		p++;
	}
	tp->x1 = x1;
	tp->y1 = y1;
	tp->x2 = x2;
	tp->y2 = y2;
	info.changed = TRUE;
	draw_text(l_track[i].t +l_track[i].nt, FALSE);
	l_track[i].nt++;
	return;
}

/******************************************

		kopiert oder verschiebt Elemente aus Block auf anderen Layer

******************************************/
int cm_plane(move)
int		move;
{
	register	DotTyp	*dt;
	register	LineTyp	*lt, *lt1;
	register	AreaTyp	*at, *at1;
				TextTyp	*tt, *tt1;
				EleTyp	*et;
	register	int		i;
				int		j, xr, yr, n;

	if (act_block.on != 2)
		return(FALSE);
	if (mbl_actblk())
		return(FALSE);
	act_coord(&xr, &yr);
	j = -1;
	for (i = 0; i < MAXLAYER; i++)
		if (l_track[i].on)
			if (j >= 0)
			{
				say_error("there must be one source layer");
				return(FALSE);
			}
			else
				j = i;
	if (j == info.cmplane)
		return(cm_block(move));
	head.offx = act_block.x1;
	head.offy = act_block.y1;
	head.minx = act_block.x1;
	head.miny = act_block.y1;
	head.maxx = act_block.x2;
	head.maxy = act_block.y2;
	if (chk_head(xr, yr))
	{
		say_error("can't copy or move block");
		return(FALSE);
	}
	if (element.on)
	{
		et = element.e;
		i = 0;
		n = element.n;
		while (i < n && element.n < MAXELEM)
		{
			if (LAT_IN_BLK(et))
			{
				if (move)
					draw_element(et, TRUE);
				else
					*(element.e +element.n++) = *et;
				rot_elem(et, 1, xr, yr, &head);
				draw_element(et, FALSE);
			}
			i++;
			et++;
		}
	}
	if (d_data.on)
	{
		dt = d_data.d;
		n = d_data.n;
		i = 0;
		while (i < n && d_data.n < MAXDOTS)
		{
			if (D_IN_BLK(dt))
			{
				if (move)
					clear_dot(dt);
				else
				{
					*(d_data.d +d_data.n++) = *dt;
					dt->name[0] = '\0';
				}
				rot_dot(dt, 1, xr, yr, &head);
				draw_dot(dt);
			}
			i++;
			dt++;
		}
	}
	lt = l_track[j].l;
	at = l_track[j].a;
	tt = l_track[j].t;
	lt1 = l_track[info.cmplane].l +l_track[info.cmplane].n;
	at1 = l_track[info.cmplane].a +l_track[info.cmplane].na;
	tt1 = l_track[info.cmplane].t +l_track[info.cmplane].nt;
	i = 0;
	while (i < l_track[j].n && l_track[info.cmplane].n < MAXLINES)
	{
		if (LAT_IN_BLK(lt))
		{
			if (move)
			{
				draw_track(lt, TRUE);
				*lt1 = *lt;
				rot_line(lt1, 1, xr, yr, &head);
				if (l_track[info.cmplane].on)
					draw_track(lt1, FALSE);
				lt1++;
				l_track[info.cmplane].n++;
				*lt = *(l_track[j].l +(--l_track[j].n));
			}
			else
			{
				*lt1 = *lt;
				rot_line(lt1, 1, xr, yr, &head);
				if (l_track[info.cmplane].on)
					draw_track(lt1, FALSE);
				lt1++;
				l_track[info.cmplane].n++;
				lt++;
				i++;
			}
		}
		else
		{
			i++;
			lt++;
		}
	}
	i = 0;
	while (i < l_track[j].na && l_track[info.cmplane].na < MAXAREA)
	{
		if (LAT_IN_BLK(at))
		{
			if (move)
			{
				draw_area(at, TRUE);
				*at1 = *at;
				rot_area(at1, 1, xr, yr, &head);
				if (l_track[info.cmplane].on)
					draw_area(at1, FALSE);
				at1++;
				l_track[info.cmplane].na++;
				*at = *(l_track[j].a +(--l_track[j].na));
			}
			else
			{
				*at1 = *at;
				rot_area(at1, 1, xr, yr, &head);
				if (l_track[info.cmplane].on)
					draw_area(at1, FALSE);
				at1++;
				l_track[info.cmplane].na++;
				at++;
				i++;
			}
		}
		else
		{
			i++;
			at++;
		}
	}
	i = 0;
	while (i < l_track[j].nt && l_track[info.cmplane].nt < MAXTEXT)
	{
		if (LAT_IN_BLK(tt))
		{
			if (move)
			{
				draw_text(tt, TRUE);
				*tt1 = *tt;
				rot_text(tt1, 1, xr, yr, &head);
				if (l_track[info.cmplane].on)
					draw_text(tt1, FALSE);
				tt1++;
				l_track[info.cmplane].nt++;
				*tt = *(l_track[j].t +(--l_track[j].nt));
			}
			else
			{
				*tt1 = *tt;
				rot_text(tt1, 1, xr, yr, &head);
				if (l_track[info.cmplane].on)
					draw_text(tt1, FALSE);
				tt1++;
				l_track[info.cmplane].nt++;
				tt++;
				i++;
			}
		}
		else
		{
			i++;
			tt++;
		}
	}
	return(TRUE);
}

/******************************************

		kopiert oder verschiebt Elemente aus Block

******************************************/
int cm_block(move)
int		move;
{
	register	DotTyp	*dt;
	register	LineTyp	*lt;
	register	AreaTyp	*at;
	register	TextTyp	*tt;
	register	EleTyp	*et;
	register	int		i;
				int		j, n, na, nt, xr, yr;

	if (act_block.on != 2)
		return(FALSE);
	if (mbl_actblk())
		return(FALSE);
	act_coord(&xr, &yr);
	head.offx = act_block.x1;
	head.offy = act_block.y1;
	head.minx = act_block.x1;
	head.miny = act_block.y1;
	head.maxx = act_block.x2;
	head.maxy = act_block.y2;
	if (chk_head(xr, yr))
	{
		say_error("can't copy or move block");
		return(FALSE);
	}
	if (element.on)
	{
		et = element.e;
		i = 0;
		n = element.n;
		while (i < n && element.n < MAXELEM)
		{
			if (LAT_IN_BLK(et))
			{
				if (move)
					draw_element(et, TRUE);
				else
					*(element.e +element.n++) = *et;
				rot_elem(et, 1, xr, yr, &head);
				draw_element(et, FALSE);
			}
			i++;
			et++;
		}
	}
	if (d_data.on)
	{
		dt = d_data.d;
		n = d_data.n;
		i = 0;
		while (i < n && d_data.n < MAXDOTS)
		{
			if (D_IN_BLK(dt))
			{
				if (move)
					clear_dot(dt);
				else
				{
					*(d_data.d +d_data.n++) = *dt;
					dt->name[0] = '\0';
				}
				rot_dot(dt, 1, xr, yr, &head);
				draw_dot(dt);
			}
			i++;
			dt++;
		}
	}
	for (j = 0; j < MAXLAYER; j++)
		if (l_track[j].on)
		{
			i = 0;
			lt = l_track[j].l;
			at = l_track[j].a;
			tt = l_track[j].t;
			n = l_track[j].n;
			na = l_track[j].na;
			nt = l_track[j].nt;
			while (i < n && l_track[j].n < MAXLINES)
			{
				if (LAT_IN_BLK(lt))
				{
					if (move)
						draw_track(lt, TRUE);
					else
						*(l_track[j].l +l_track[j].n++) = *lt;
					rot_line(lt, 1, xr, yr, &head);
					draw_track(lt, FALSE);
				}
				i++;
				lt++;
			}
			i = 0;
			while (i < na && l_track[j].na < MAXAREA)
			{
				if (LAT_IN_BLK(at))
				{
					if (move)
						draw_area(at, TRUE);
					else
						*(l_track[j].a +l_track[j].na++) = *at;
					rot_area(at, 1, xr, yr, &head);
					draw_area(at, FALSE);
				}
				i++;
				at++;
			}
			i = 0;
			while (i < nt && l_track[j].nt < MAXTEXT)
			{
				if (LAT_IN_BLK(tt))
				{
					if (move)
						draw_text(tt, TRUE);
					else
						*(l_track[j].t +l_track[j].nt++) = *tt;
					rot_text(tt, 1, xr, yr, &head);
					draw_text(tt, FALSE);
				}
				i++;
				tt++;
			}
		}
	return(TRUE);
}

/******************************************

		loescht Elemente aus Block

******************************************/
void clr_block()
{
	register	DotTyp	*dt;
	register	LineTyp	*lt;
	register	AreaTyp	*at;
	register	TextTyp	*tt;
	register	int		i;
				int		j;

	if (d_data.on)
	{
		dt = d_data.d;
		i = 0;
		while (i < d_data.n)
		{
			if (D_IN_BLK(dt))
			{
				clear_dot(dt);
				d_data.n--;
				*dt = *(d_data.d +d_data.n);
			}
			else
			{
				i++;
				dt++;
			}
		}
	}
	for (j = 0; j < MAXLAYER; j++)
		if (l_track[j].on)
		{
			i = 0;
			lt = l_track[j].l;
			at = l_track[j].a;
			tt = l_track[j].t;
			while (i < l_track[j].n)
			{
				if (LAT_IN_BLK(lt))
				{
					draw_track(lt, TRUE);
					*lt = *(l_track[j].l + --l_track[j].n);
				}
				else
				{
					i++;
					lt++;
				}
			}
			i = 0;
			while (i < l_track[j].na)
			{
				if (LAT_IN_BLK(at))
				{
					draw_area(at, TRUE);
					*at = *(l_track[j].a + --l_track[j].na);
				}
				else
				{
					i++;
					at++;
				}
			}
			i = 0;
			while (i < l_track[j].nt)
			{
				if (LAT_IN_BLK(tt))
				{
					draw_text(tt, TRUE);
					*tt = *(l_track[j].t + --l_track[j].nt);
				}
				else
				{
					i++;
					tt++;
				}
			}
		}
}

/******************************************

		passt Linien an 45 Grad Winkel an

******************************************/
void set_angle()
{
	register	int		dx, dy;
				int		x, y, min;
				double	m;

	act_coord(&x, &y);
	dx = x -act_line.x1;
	dy = y -act_line.y1;
	if (dx == 0)
	{
		if (dy == 0)
		{
			act_line.d = -1;
			return;
		}
		else
			act_line.d = (dy > 0) ? 0 : 4;
	}
	else
	{
		m = (double) dy /(double) dx;
		act_line.d = 2;
		if (m > ANGCONST1)
			act_line.d = ((m > ANGCONST2) ? 0 : 1);
		else
			if (m < -ANGCONST1)
				act_line.d = ((m < -ANGCONST2) ? 0 : 3);
	}
	if (dx < 0)
		act_line.d += 4;
	dx = abs(dx);
	dy = abs(dy);
	min = (dx < dy) ? dx : dy;
	switch(act_line.d)
	{
		case	0	:
		case	4	:	act_line.x2 = act_line.x1;
						act_line.y2 = y;
						break;
		case	2	:
		case	6	:	act_line.y2 = act_line.y1;
						act_line.x2 = x;
						break;
		case	1	:	act_line.x2 = act_line.x1 +min;
						act_line.y2 = act_line.y1 +min;
						break;
		case	3	:	act_line.x2 = act_line.x1 +min;
						act_line.y2 = act_line.y1 -min;
						break;
		case	5	:	act_line.x2 = act_line.x1 -min;
						act_line.y2 = act_line.y1 -min;
						break;
		case	7	:	act_line.x2 = act_line.x1 -min;
						act_line.y2 = act_line.y1 +min;
						break;
		default		: 	break;
	}
}

/******************************************

		initialisiert Pins und Track

******************************************/
void init_dl()
{
	int		i, j;

	for (i = 0; i < ZOOMMAX; i++)
	{
		for (j = 0; j < LINETYPES; j++)
			init_line(i, linewidth[j], &track[i][j]);
		for (j = 0; j < DOTTYPES; j++)
			init_dot(i, dotwidth[j], &dot[i][j]);
	}
}

/******************************************

		initialisiert tracklayout

******************************************/
void init_line(z, r, ll)
int		z, r;
LLayout	*ll;
{
	static	FXY	p0[8] = {{       0.5, -TAN_CONST},
						 { TAN_CONST,       -0.5},
						 {-TAN_CONST,       -0.5},
						 {      -0.5, -TAN_CONST},
						 {      -0.5,  TAN_CONST},
						 {-TAN_CONST,        0.5},
						 { TAN_CONST,        0.5},
						 {       0.5,  TAN_CONST}};
	double	r1;
	int		i;

	r1 = r *zoom[z];
	for (i = 0; i < 8; i++)
	{
		ll->out[i].x = (int) (p0[i].x *r1);
		ll->out[i].y = (int) (p0[i].y *r1);
	}
}

/******************************************

		initialisiert Pinlayout

******************************************/
void init_dot(z, r, dl)
int		z, r;
DLayout	*dl;
{
	static	FXY	p0[8] = {{       0.5, -TAN_CONST},
						 { TAN_CONST,       -0.5},
						 {-TAN_CONST,       -0.5},
						 {      -0.5, -TAN_CONST},
						 {      -0.5,  TAN_CONST},
						 {-TAN_CONST,        0.5},
						 { TAN_CONST,        0.5},
						 {       0.5,  TAN_CONST}};
	double	r1, r2;
	int		i;

	r1 = r *zoom[z];
	r2 = DOTHOLE *zoom[z];
	for (i = 0; i < 8; i++)
	{
		dl->in[i].x = (int) (p0[i].x *r2);
		dl->in[i].y = (int) (p0[i].y *r2);
		dl->out[i].x = (int) (p0[i].x *r1);
		dl->out[i].y = (int) (p0[i].y *r1);
	}
}

/******************************************

		setzt Loetauge

******************************************/
void set_dot()
{
	register	DotTyp	*dt;
				int		x, y;

	if (!d_data.on)
		return;
	act_coord(&x, &y);
	if (d_data.n < MAXDOTS)
	{
		dt = d_data.d +d_data.n;
		dt->x = x;
		dt->y = y;
		dt->s = (char) info.dl;
		dt->used = FALSE;
		dt->name[0] = '\0';
		cursor_off();
		draw_dot(dt);
		d_data.n++;
		cursor_on();
	}
}

/******************************************

		loescht Loetauge

******************************************/
void del_dot()
{
	register	DotTyp	*dt;
	register	int		i, found;
				int		x, y;

	if (!d_data.on)
		return;
	act_coord(&x, &y);
	dt = d_data.d;
	found = FALSE;
	for (i = 0; i < d_data.n && !found; i++, dt++)
		if (dt->x == x && dt->y == y) 
		{
			found = TRUE;
			cursor_off();
			clear_dot(dt);
			d_data.n--;
			*dt = *(d_data.d +d_data.n);
			cursor_on();
		}
}

/******************************************

		sucht Text in Layer

******************************************/
int sea_text(l)
Lines	*l;
{
	register	TextTyp	*tt;
	register	int		i;
				int		x, y;

	if (!l->on)
		return(-1);
	act_coord(&x, &y);
	tt = l->t;
	for (i = 0; i < l->nt; i++, tt++)
		if (x >= tt->x1 && x <= tt->x2 && y >= tt->y1 && y <= tt->y2)
			return(i);
	return(-1);
}

/******************************************

		sucht Flaeche in Layer

******************************************/
int sea_area(l)
Lines	*l;
{
	register	AreaTyp	*at;
	register	int		i;
				int		x, y;

	if (!l->on)
		return(-1);
	act_coord(&x, &y);
	at = l->a;
	for (i = 0; i < l->na; i++, at++)
		if (x >= at->x1 && x <= at->x2 && y >= at->y1 && y <= at->y2)
			return(i);
	return(-1);
}

/******************************************

		sucht Track in Layer

******************************************/
int sea_track(l)
Lines	*l;
{
	register	LineTyp	*lt;
	register	int		i;
				int		x, y;
	static		char	s[80];

	if (!l->on)
		return(-1);
	act_coord(&x, &y);
	lt = l->l;
	for (i = 0; i < l->n; i++, lt++)
		switch(lt->d)
		{
			case 0 :	if (x == lt->x1 && y >= lt->y1 && y <= lt->y2)
							return(i);
						break;
			case 1 :	if ((x - lt->x1) == (y - lt->y1) && x >= lt->x1 && x <= lt->x2 && y >= lt->y1 && y <= lt->y2)
							return(i);
						break;
			case 2 :	if (y == lt->y1 && x >= lt->x1 && x <= lt->x2)
							return(i);
						break;
			case 3 :	if ((x - lt->x1) == (lt->y1 - y) && x >= lt->x1 && x <= lt->x2 && y <= lt->y1 && y >= lt->y2)
							return(i);
						break;
			default:	sprintf(s,"illegal direction %i at track %i", (int) lt->d, i);
						say_error(s);
						set_dir(lt);
						lt--;
						i--;
						break;
		}
	return(-1);
}

/******************************************

		sucht Text in allen Layers

******************************************/
Lines *all_text(pos)
int	*pos;
{
	register	int		i;

	if ((*pos = sea_text(&l_track[info.plane])) >= 0)
		return(&l_track[info.plane]);
	i = 0;
	while (i < MAXLAYER)
		if ((*pos = sea_text(&l_track[i])) >= 0)
			return(&l_track[i]);
		else
			i++;
	return((Lines *) NULL);
}

/******************************************

		sucht Flaeche in allen Layers

******************************************/
Lines *all_area(pos)
int	*pos;
{
	register	int		i;

	if ((*pos = sea_area(&l_track[info.plane])) >= 0)
		return(&l_track[info.plane]);
	i = 0;
	while (i < MAXLAYER)
		if ((*pos = sea_area(&l_track[i])) >= 0)
			return(&l_track[i]);
		else
			i++;
	return((Lines *) NULL);
}

/******************************************

		sucht Track in allen Layers

******************************************/
Lines *all_track(pos)
int	*pos;
{
	register	int		i;

	if ((*pos = sea_track(&l_track[info.plane])) >= 0)
		return(&l_track[info.plane]);
	i = 0;
	while (i < MAXLAYER)
		if ((*pos = sea_track(&l_track[i])) >= 0)
			return(&l_track[i]);
		else
			i++;
	return((Lines *) NULL);
}

/******************************************

		loescht Track

******************************************/
void del_track()
{
	register	Lines	*l;
	register	LineTyp	*lt;
				int		i;

	if ((l = all_track(&i)) != NULL)
	{
		lt = l->l +i;
		cursor_off();
		draw_track(lt, TRUE);
		cursor_on();
		*lt = *(l->l + --l->n);
	}
}

/******************************************

		setzt Flaeche

******************************************/
void set_area()
{
	register	Lines	*l;
	register	AreaTyp	*at;
				int		x1, x2, y1, y2;

	l = &l_track[info.plane];
	if (!l->on)
		return;
	x1 = act_block.x1;
	x2 = act_block.x2;
	y1 = act_block.y1;
	y2 = act_block.y2;
	if (l->na < MAXAREA && x1 != x2 && y1 != y2)
	{
		at = l->a +l->na;
		at->x1 = x1;
		at->y1 = y1;
		at->x2 = x2;
		at->y2 = y2;
		at->used = FALSE;
		draw_area(at, FALSE);
		l->na++;
	}
}

/******************************************

		loescht Text

******************************************/
void del_text()
{
	register	Lines	*l;
	register	TextTyp	*tt;
				int		i;

	if ((l = all_text(&i)) != NULL)
	{
		tt = l->t +i;
		cursor_off();
		draw_text(tt, TRUE);
		cursor_on();
		*tt = *(l->t + --l->nt);
	}
}

/******************************************

		loescht Flaeche

******************************************/
void del_area()
{
	register	Lines	*l;
	register	AreaTyp	*at;
				int		i;

	if ((l = all_area(&i)) != NULL)
	{
		at = l->a +i;
		cursor_off();
		draw_area(at, TRUE);
		cursor_on();
		*at = *(l->a + --l->na);
	}
}

/******************************************

		kopiert stack

******************************************/
void copy_stack()
{
	register	Lines	*l;
	register	LineTyp	*lt, *st;
				int		i;
				int		x, y, x1, y1, x2, y2;

	l = &l_track[info.plane];
	if (!l->on)
		return;
	act_coord(&x, &y);
	st = l_stack.l;
	for (i = 0; i < l_stack.n; i++, st++)
	{
		x1 = x +st->x1 -info.sx;
		y1 = y +st->y1 -info.sy;
		x2 = x +st->x2 -info.sx;
		y2 = y +st->y2 -info.sy;
		if (l->n < MAXLINES &&
			x1 >= 0 && x1 <= XMAX && x2 >= 0 && x2 <= XMAX &&
			y1 >= 0 && y1 <= YMAX && y2 >= 0 && y2 <= YMAX)
		{
			lt = l->l +l->n;
			lt->x1 = x1;
			lt->y1 = y1;
			lt->x2 = x2;
			lt->y2 = y2;
			lt->d  = st->d;
			lt->s  = st->s;
			lt->used = FALSE;
			draw_track(lt, FALSE);
			l->n++;
		}
	}
}

/******************************************

		setzt Track

******************************************/
void set_track()
{
	register	Lines	*l;
	register	LineTyp	*lt;

	l = &l_track[info.plane];
	if (!l->on)
		return;
	if (l->n < MAXLINES && act_line.d >= 0)
	{
		lt = l->l +l->n;
		lt->x1 = act_line.x1;
		lt->y1 = act_line.y1;
		lt->x2 = act_line.x2;
		lt->y2 = act_line.y2;
		lt->s  = info.ll;
		lt->used = FALSE;
		set_dir(lt);
		if (l_stack.on && l_stack.n < MAXSTACK)
		{
			*(l_stack.l +l_stack.n) = *lt;
			l_stack.n++;
		}
		draw_track(lt, FALSE);
		l->n++;
	}
}

/******************************************

		aendert Dot size

******************************************/
void chg_dsize()
{
	register	DotTyp	*dt;
	register	int		i;
				int		x, y;

	if (!d_data.on)
		return;
	act_coord(&x, &y);
	cursor_off();
	dt = d_data.d;
	for (i = 0; i < d_data.n; i++, dt++)
		if (dt->x == x && dt->y == y) 
		{
			clear_dot(dt);
			if (++dt->s >= DOTTYPES) 
				dt->s = 0;
			draw_dot(dt);
		}
	cursor_on();
}

/******************************************

		aendert Dot size im Block

******************************************/
void chg_dbsize()
{
	register	DotTyp	*dt;
	register	int		i;
				int		x, y;

	if (!d_data.on || act_block.on != 2)
		return;
	act_coord(&x, &y);
	cursor_off();
	dt = d_data.d;
	for (i = 0; i < d_data.n; i++, dt++)
		if (D_IN_BLK(dt))
		{
			clear_dot(dt);
			if (++dt->s >= DOTTYPES) 
				dt->s = 0;
			draw_dot(dt);
		}
	cursor_on();
}

/******************************************

		aendert Track size im Block

******************************************/
void chg_bsize()
{
	register	LineTyp	*lt;
	register	int		i;
				int		j;

	if (act_block.on != 2)
		return;
	cursor_off();
	for (j = 0; j < MAXLAYER; j++)
		if (l_track[j].on)
			for (i = 0,  lt = l_track[j].l; i < l_track[j].n; i++, lt++)
				if (LAT_IN_BLK(lt))
				{
					draw_track(lt, TRUE);
					if (++lt->s >= LINETYPES)
						lt->s = 0;
					draw_track(lt, FALSE);
				}
	cursor_on();
}


/******************************************

		aendert Track size

******************************************/
void chg_size()
{
	register	Lines	*l;
	register	LineTyp	*lt;
				int		i;

	if ((l = all_track(&i)) != NULL)
	{
		lt = l->l +i;
		cursor_off();
		draw_track(lt, TRUE);
		if (++lt->s >= LINETYPES)
			lt->s = 0;
		draw_track(lt, FALSE);
		cursor_on();
	}
}

/******************************************

		gibt Loetauge aus (ohne Loch)

******************************************/
void draw_full_dot(dt)
register	DotTyp	*dt;
{
	int		x, y, x1, x2, y1, y2, y3, y4, s;

	scr_coord(dt->x, dt->y, &x, &y);
	s = dt->s;
	if ((x2 = x+ dot[info.zoom][s].out[1].x) < 0 ||
		(x1 = x+ dot[info.zoom][s].out[2].x) > XSCREEN ||
		(y1 = y+ dot[info.zoom][s].out[2].y) > YSCREEN ||
		(y4 = y+ dot[info.zoom][s].out[5].y) < 0)
		return;
	y2 = y+ dot[info.zoom][s].out[3].y;
	y3 = y+ dot[info.zoom][s].out[4].y;
	while (y1 < y2)
		o_chline(x1--, x2++, y1++);
	o_cblk(x1, y2, x2, y3);
	while (y3 <= y4)
		o_chline(x1++, x2--, y3++);
}

/******************************************

		gibt Loetauge aus

******************************************/
void draw_dot(dt)
register	DotTyp	*dt;
{
	int		x, y, x1, x2, y1, y2, y3, y4, s;

	scr_coord(dt->x, dt->y, &x, &y);
	s = dt->s;
	if ((x2 = x+ dot[info.zoom][s].out[1].x) < 0 ||
		(x1 = x+ dot[info.zoom][s].out[2].x) > XSCREEN ||
		(y1 = y+ dot[info.zoom][s].out[2].y) > YSCREEN ||
		(y4 = y+ dot[info.zoom][s].out[5].y) < 0)
		return;
	y2 = y+ dot[info.zoom][s].out[3].y;
	y3 = y+ dot[info.zoom][s].out[4].y;
	while (y1 < y2)
	{
		o_chline(x1, x2, y4--);
		o_chline(x1--, x2++, y1++);
	}
	o_cblk(x1, y2, x2, y3);
	x2 = x+ dot[info.zoom][s].in[1].x;
	x1 = x+ dot[info.zoom][s].in[2].x;
	y1 = y+ dot[info.zoom][s].in[2].y;
	y2 = y+ dot[info.zoom][s].in[3].y;
	y3 = y+ dot[info.zoom][s].in[4].y;
	y4 = y+ dot[info.zoom][s].in[5].y;
	while (y1 < y2)
	{
		o_chdlin(x1, x2, y4--);
		o_chdlin(x1--, x2++, y1++);
	}
	o_cdblk(x1, y2, x2, y3);
}

/******************************************

		loescht Loetauge vom Schirm

******************************************/
void clear_dot(dt)
register	DotTyp	*dt;
{
	int		x, y, x1, x2, y1, y2, y3, y4, s;

	scr_coord(dt->x, dt->y, &x, &y);
	s = dt->s;
	if ((x2 = x+ dot[info.zoom][s].out[1].x) < 0 ||
		(x1 = x+ dot[info.zoom][s].out[2].x) > XSCREEN ||
		(y1 = y+ dot[info.zoom][s].out[2].y) > YSCREEN ||
		(y4 = y+ dot[info.zoom][s].out[5].y) < 0)
		return;
	y2 = y+ dot[info.zoom][s].out[3].y;
	y3 = y+ dot[info.zoom][s].out[4].y;
	while (y1 < y2)
	{
		o_chdlin(x1, x2, y4--);
		o_chdlin(x1--, x2++, y1++);
	}
	o_cdblk(x1, y2, x2, y3);
}

/******************************************

		gibt Flaeche aus oder loescht vom Schirm

******************************************/
void draw_area(at, del)
register	AreaTyp	*at;
			int 	del;
{
	int		x1, y1, x2, y2;

	scr_coord(at->x1, at->y1, &x1, &y1);
	scr_coord(at->x2, at->y2, &x2, &y2);
	if (del)
		o_cdblk(x1, y1, x2, y2);
	else
		o_cblk(x1, y1, x2, y2);
}

/******************************************

		gibt Text aus oder loescht vom Schirm

******************************************/
void draw_text(tp, del)
register	TextTyp	*tp;
			int		del;
{
	register	int		i, dx;
	register	char	*s;
	register	int		x, y;
				LineTyp	lt;
	unsigned	int		k, save;

	x = tp->x;
	y = tp->y;
	s = tp->t;
	save = info.rot;
	info.rot = tp->rot;
	while (*s)
	{
		k = *s;
		if (keys[k].l)
		{
			if (tp->mir)
			{
				for (i = 0; i < keys[k].n; i++)
				{
					lt = *(keys[k].l +i);
					lt.x1 = keys[k].h.minx -lt.x1 +keys[k].h.maxx;
					lt.x2 = keys[k].h.minx -lt.x2 +keys[k].h.maxx;
					set_dir(&lt);
					rot_line(&lt, 1, x, y, &keys[k].h);
					draw_track(&lt, del);
				}
			}
			else
				for (i = 0; i < keys[k].n; i++)
				{
					lt = *(keys[k].l +i);
					rot_line(&lt, 1, x, y, &keys[k].h);
					draw_track(&lt, del);
				}
			dx = keys[k].h.maxx -keys[k].h.minx +2;
		}
		else
			dx = BLANKCHAR;
		switch(info.rot)
		{
			case 0 :	x += dx;
						break;
			case 1 :	y += dx;
						break;
			case 2 :	x -= dx;
						break;
			case 3 :	y -= dx;
						break;
			default:	break;
		}
		s++;
	}
	info.rot = save;
}

/******************************************

		gibt Track aus oder loescht vom Schirm

******************************************/
void draw_track(lt, del)
register	LineTyp	*lt;
			int 	del;
{
	register	int		i, j, x1, x2, y1, y2;
				int		d, s;
				XY		p[8];

	scr_coord(lt->x1, lt->y1, &d, &s);
	x1 = d, y1 = s;
	scr_coord(lt->x2, lt->y2, &d, &s);
	x2 = d, y2 = s;
	s = lt->s;
	d = lt->d;
	for (i = 0; i < 8; i++)
	{
		j = (i +d) & 0x07;
		if (i < 4)
		{
			p[i].x = x1+ track[info.zoom][s].out[j].x;
			p[i].y = y1+ track[info.zoom][s].out[j].y;
		}
		else
		{
			p[i].x = x2+ track[info.zoom][s].out[j].x;
			p[i].y = y2+ track[info.zoom][s].out[j].y;
		}
	}
	if (del)
		switch(d)
		{
			case 0 : o_cdblk(p[3].x, p[3].y, p[7].x, p[7].y);
					 x2 = p[0].x-1;
					 y1 = p[0].y-1;
					 for (x1 = p[3].x+1; y1 >= p[2].y ;)
					 	o_chdlin(x1++, x2--, y1--);
					 x2 = p[7].x-1;
					 y1 = p[4].y+1;
					 for (x1 = p[4].x+1; y1 <= p[5].y ;)
					 	o_chdlin(x1++, x2--, y1++);
					 break;
			case 1 : x1 = p[1].x;
					 x2 = p[0].x;
					 y1 = p[1].y;
					 while (y1 < p[2].y)
					 	o_chdlin(x1--, x2++, y1++);
					 while (y1 < p[3].y)
					 	o_chdlin(x1, x2++, y1++);
					 if (y1 < 0)
					 {
					 	if (p[7].y < 0)
					 	{
					 		i = y1 -p[7].y;
					 		x1 -= i, x2 -= i; y1 = p[7].y;
					 	}
					 	else
						 	x1 -= y1, x2 -= y1, y1 = 0;
					 }
					 while (y1 < p[7].y)
					 {
					 	if (y1 > YSCREEN) return;
					 	o_chdlin(x1++, x2++, y1++);
					 }
					 while (y1 < p[6].y)
					 	o_chdlin(x1++, x2, y1++);
					 while (y1 <= p[4].y)
					 	o_chdlin(x1++, x2--, y1++);
					 break;
			case 2 : o_cdblk(p[1].x, p[1].y, p[5].x, p[5].y);
					 x2 = p[6].x-1;
					 y1 = p[6].y-1;
					 for (x1 = p[1].x+1; y1 >= p[0].y ;)
					 	o_chdlin(x1++, x2--, y1--);
					 x2 = p[5].x-1;
					 y1 = p[5].y+1;
					 for (x1 = p[2].x+1; y1 <= p[3].y ;)
					 	o_chdlin(x1++, x2--, y1++);
					 break;
			case 3 : x1 = p[7].x;
					 x2 = p[6].x;
					 y1 = p[7].y;
					 while (y1 < p[5].y)
					 	o_chdlin(x1--, x2++, y1++);
					 while (y1 < p[4].y)
					 	o_chdlin(x1--, x2, y1++);
					 if (y1 < 0)
					 {
					 	if (p[0].y < 0)
					 	{
					 		i = y1 -p[0].y;
					 		x1 += i, x2 += i; y1 = p[0].y;
					 	}
					 	else
						 	x1 += y1, x2 += y1, y1 = 0;
					 }
					 while (y1 < p[0].y)
					 {
					 	if (y1 > YSCREEN) return;
					 	o_chdlin(x1--, x2--, y1++);
					 }
					 while (y1 < p[1].y)
					 	o_chdlin(x1, x2--, y1++);
					 while (y1 <= p[2].y)
					 	o_chdlin(x1++, x2--, y1++);
			default :break;
		}
	else
		switch(d)
		{
			case 0 : o_cblk(p[3].x, p[3].y, p[7].x, p[7].y);
					 x2 = p[0].x-1;
					 y1 = p[0].y-1;
					 for (x1 = p[3].x+1; y1 >= p[2].y ;)
					 	o_chline(x1++, x2--, y1--);
					 x2 = p[7].x-1;
					 y1 = p[4].y+1;
					 for (x1 = p[4].x+1; y1 <= p[5].y ;)
					 	o_chline(x1++, x2--, y1++);
					 break;
			case 1 : x1 = p[1].x;
					 x2 = p[0].x;
					 y1 = p[1].y;
					 while (y1 < p[2].y)
					 	o_chline(x1--, x2++, y1++);
					 while (y1 < p[3].y)
					 	o_chline(x1, x2++, y1++);
					 if (y1 < 0)
					 {
					 	if (p[7].y < 0)
					 	{
					 		i = y1 -p[7].y;
					 		x1 -= i, x2 -= i; y1 = p[7].y;
					 	}
					 	else
						 	x1 -= y1, x2 -= y1, y1 = 0;
					 }
					 while (y1 < p[7].y)
					 {
					 	if (y1 > YSCREEN) return;
					 	o_chline(x1++, x2++, y1++);
					 }
					 while (y1 < p[6].y)
					 	o_chline(x1++, x2, y1++);
					 while (y1 <= p[4].y)
					 	o_chline(x1++, x2--, y1++);
					 break;
			case 2 : o_cblk(p[1].x, p[1].y, p[5].x, p[5].y);
					 x2 = p[6].x-1;
					 y1 = p[6].y-1;
					 for (x1 = p[1].x+1; y1 >= p[0].y ;)
					 	o_chline(x1++, x2--, y1--);
					 x2 = p[5].x-1;
					 y1 = p[5].y+1;
					 for (x1 = p[2].x+1; y1 <= p[3].y ;)
					 	o_chline(x1++, x2--, y1++);
					 break;
			case 3 : x1 = p[7].x;
					 x2 = p[6].x;
					 y1 = p[7].y;
					 while (y1 < p[5].y)
					 	o_chline(x1--, x2++, y1++);
					 while (y1 < p[4].y)
					 	o_chline(x1--, x2, y1++);
					 if (y1 < 0)
					 {
					 	if (p[0].y < 0)
					 	{
					 		i = y1 -p[0].y;
					 		x1 += i, x2 += i; y1 = p[0].y;
					 	}
					 	else
						 	x1 += y1, x2 += y1, y1 = 0;
					 }
					 while (y1 < p[0].y)
					 {
					 	if (y1 > YSCREEN) return;
					 	o_chline(x1--, x2--, y1++);
					 }
					 while (y1 < p[1].y)
					 	o_chline(x1, x2--, y1++);
					 while (y1 <= p[2].y)
					 	o_chline(x1++, x2--, y1++);
			default :break;
		}
}

/******************************************

		setzt Pinnamen

******************************************/
void set_pinname()
{
	register	int		i;
	register	DotTyp	*dt;
				char	s[81];
				int		x, y;

	act_coord(&x, &y);
	dt = d_data.d;
	for (i = 0; i < d_data.n; i++, dt++)
		if (dt->x == x && dt->y == y)
		{
			strcpy(s, dt->name);
			if (get_instr("pinname: ", s))
			{
				strncpy(dt->name, s, PNAMLEN-1);
				dt->name[PNAMLEN-1] = '\0';
				info.changed = TRUE;
				return;
			}
		}
}

/******************************************

		Zuweisung von "string1,string2" an string1 und string2

******************************************/
void split_string(s, s1, s2)
char *s, *s1, *s2;
{
	*s1 = *s2 = '\0';
	while (*s && *s != ',')
		*s1++ = *s++;
	*s1 = '\0';
	if (*s) s++;
	while (*s)
		*s2++ = *s++;
	*s2 = '\0';
}

/******************************************

		setzt Element

******************************************/
void set_element(name)
char *name;
{
	register	int		i;
	register	EleTyp	*et;
				char	s[81],
						n1[81],
						n2[81];
				int		x, y, len;

	if (name[0])
	{
		if (act_block.on == 2)
		{
			if (element.n >= MAXELEM+1)
			{
				say_error("out of memory...");
				return;
			}
			et = element.e +element.n;
			act_coord(&et->mx, &et->my);
			et->x1 = MIN(act_block.x1, act_block.x2);
			et->y1 = MIN(act_block.y1, act_block.y2);
			et->x2 = MAX(act_block.x1, act_block.x2);
			et->y2 = MAX(act_block.y1, act_block.y2);
			split_string(name, n1, n2);
			strncpy(et->layname, n1, ENAMLEN-1);
			strncpy(et->listname, n2, ENAMLEN-1);
			et->layname[ENAMLEN-1] = '\0';
			et->listname[ENAMLEN-1] = '\0';
			len = (int) strlen(et->layname) +1;
			head.minx = head.offx = head.miny = head.offy = 0;
			head.maxx = BLANKCHAR * len;
			head.maxy = BLANKCHAR;
			if (mbl_head())
				return;
			act_coord(&et->tx, &et->ty);
			et->tr = info.rot;
			element.n++;
			if (element.on)
				draw_element(et, FALSE);
			info.changed = TRUE;
		}
		else
		{
			et = element.e;
			act_coord(&x, &y);
			for (i = 0; i < element.n; i++, et++)
			{
				if (x >= et->x1 && x <= et->x2 && y >= et->y1 && y <= et->y2)
				{
					split_string(name, n1, n2);
					strncpy(et->layname, n1, ENAMLEN-1);
					strncpy(et->listname, n2, ENAMLEN-1);
					et->layname[ENAMLEN-1] = '\0';
					et->listname[ENAMLEN-1] = '\0';
					info.changed = TRUE;
					return;
				}
			}
		}
	}
	else
	{
		et = element.e;
		act_coord(&x, &y);
		if (act_block.on == 2)
		{
			for (i = 0; i < element.n; i++, et++)
			{
				if (LAT_IN_BLK(et))
				{
					sprintf(s, "%s,%s", et->layname, et->listname);
					if (!get_instr("layer-name, connection-name: ", s))
						return;
					split_string(s, n1, n2);
					strncpy(et->layname, n1, ENAMLEN-1);
					strncpy(et->listname, n2, ENAMLEN-1);
					et->layname[ENAMLEN-1] = '\0';
					et->listname[ENAMLEN-1] = '\0';
					info.changed = TRUE;
					return;
				}
			}
		}
		else
		{
			for (i = 0; i < element.n; i++, et++)
			{
				if (x >= et->x1 && x <= et->x2 && y >= et->y1 && y <= et->y2)
				{
					sprintf(s, "%s,%s", et->layname, et->listname);
					if (!get_instr("layer-name, connection-name: ", s))
						return;
					split_string(s, n1, n2);
					strncpy(et->layname, n1, ENAMLEN-1);
					strncpy(et->listname, n2, ENAMLEN-1);
					et->layname[ENAMLEN-1] = '\0';
					et->listname[ENAMLEN-1] = '\0';
					info.changed = TRUE;
					return;
				}
			}
		}
	}
	return;
}

/******************************************

		loescht Element

******************************************/
void del_element(name)
char *name;
{
	register	int		i;
	register	EleTyp	*et;
				int		x, y;
	
	et = element.e;
	if (name[0])
	{
		for (i = 0; i < element.n; i++, et++)
		{
			if (!strcmp(name, et->layname))
			{
				if (element.on)
					draw_element(et, TRUE);
				*et = *(element.e +(--element.n));
				return;
			}
		}
	}
	act_coord(&x, &y);
	for (i = 0; i < element.n; i++, et++)
	{
		if (x >= et->x1 && y >= et->y1 && x <= et->x2 && y <= et->y2)
		{
			*et = *(element.e +(--element.n));
			if (element.on)
				update_scr();
			return;
		}
	}
}

/******************************************

		zeichnet ein Element

******************************************/
void draw_element(et, del)
register EleTyp	*et;
		 int	del;
{
	int		x1, x2, y1, y2;
	TextTyp	t;

	t.mir = FALSE;
	t.rot = et->tr;
	t.x = t.x1 = t.x2 = et->tx;
	t.y = t.y1 = t.y2 = et->ty;
	strcpy(t.t, et->layname);
	strupr(t.t);
	scr_coord(et->x1, et->y1, &x1, &y1);
	scr_coord(et->x2, et->y2, &x2, &y2);
	while (y1 <= y2)
		o_hordot(x1, x2, y1), y1 += 3;
	scr_coord(et->mx-3, et->my-3, &x1, &y1);
	scr_coord(et->mx+3, et->my+3, &x2, &y2);
	if (del)
		o_cdblk(x1, y1, x2, y2);
	else
		o_cblk(x1, y1, x2, y2);
	draw_text(&t, del);
}

/******************************************

		zeichnet alle Elementblcke

******************************************/
void draw_all_elements()
{
	register	int		i;
	register	EleTyp	*et;

	et = element.e;
	for (i = 0; i < element.n; i++, et++)
		draw_element(et, FALSE);
}

/******************************************

		zeichnet alle Tracks

******************************************/
void draw_all_tracks()
{
	register	int		i, j;
	register	Lines	*l;
	register	LineTyp	*lt;

	for (j = 0; j < MAXLAYER; j++)
		if (l_track[j].on)
		{
			l = &l_track[j];
			lt = l_track[j].l;
			for (i = 0; i < l->n; i++, lt++)
				draw_track(lt, FALSE);
		}
}

/******************************************

		zeichnet alle Flaechen

******************************************/
void draw_all_areas()
{
	register	int		i, j;
	register	Lines	*l;
	register	AreaTyp	*at;

	for (j = 0; j < MAXLAYER; j++)
		if (l_track[j].on)
		{
			l = &l_track[j];
			at = l_track[j].a;
			for (i = 0; i < l->na; i++, at++)
				draw_area(at, FALSE);
		}
}

/******************************************

		zeichnet alle Flaechen

******************************************/
void draw_all_texts()
{
	register	int		i, j;
	register	Lines	*l;
	register	TextTyp	*tt;

	for (j = 0; j < MAXLAYER; j++)
		if (l_track[j].on)
		{
			l = &l_track[j];
			tt = l_track[j].t;
			for (i = 0; i < l->nt; i++, tt++)
				draw_text(tt, FALSE);
		}
}

/******************************************

		zeichnet alle Dots die nicht kontrolliert wurden

******************************************/
void draw_not_used()
{
	register	int		i;
	register	DotTyp	*dt;

	dt = d_data.d;
	if (d_data.on)
		for (i = 0; i < d_data.n; i++, dt++)
			if (!dt->used)
				draw_dot(dt);
			else
				draw_full_dot(dt);
}

/******************************************

		zeichnet alle Dots

******************************************/
void draw_all_dots()
{
	register	int		i;
	register	DotTyp	*dt;
	
	dt = d_data.d;
	if (d_data.on)
		for (i = 0; i < d_data.n; i++, dt++)
			draw_dot(dt);
}

/******************************************

		zeichnet alle gefundenen Dots

******************************************/
void draw_found_dots()
{
	register	int		i, j;
	register	DotTyp	*dt;
	register	LineTyp	*lt;
	register	AreaTyp	*at;
	
	o_clrstat();
	o_status("press any key...");
	do
	{
		for (j = 0; j < SEASIDE; j++)
			if (l_track[j].on)
			{
				for (i = 0; i < nr_track[j]; i++)
				{
					lt = l_track[j].l +track_list[j][i];
					draw_track(lt, TRUE);
				}
				for (i = 0; i < nr_area[j]; i++)
				{
					at = l_track[j].a +area_list[j][i];
					draw_area(at, TRUE);
				}	
			}
		for (i = 0; i < nr_dot; i++)
		{
			dt = d_data.d +dot_list[i];
			clear_dot(dt);
		}
		delay(40);
		for (j = 0; j < SEASIDE; j++)
			if (l_track[j].on)
			{
				for (i = 0; i < nr_track[j]; i++)
				{
					lt = l_track[j].l +track_list[j][i];
					draw_track(lt, FALSE);
				}
				for (i = 0; i < nr_area[j]; i++)
				{
					at = l_track[j].a +area_list[j][i];
					draw_area(at, FALSE);
				}	
			}
		for (i = 0; i < nr_dot; i++)
		{
			dt = d_data.d +dot_list[i];
			draw_dot(dt);
		}
		delay(40);
	} while(!Cconis());
	for (i = 0; i < nr_dot; i++)
	{
		dt = d_data.d +dot_list[i];
		draw_full_dot(dt);
	}
	while (Cconis()) Cnecin();
}

/******************************************

		Bildschirm update

******************************************/
void update_scr()
{
	int	old;

	old = info.changed;
	cursor_save();
	o_clrscr();
	if (element.n && element.on)
		draw_all_elements();
	draw_all_tracks();
	draw_all_areas();
	draw_all_texts();
	if (info.ctrl)
		draw_not_used();
	else
		draw_all_dots();
	cursor_rec();
	update_dir();
	info.changed = old;
}

/******************************************

		Richtungs update

******************************************/
void update_dir()
{
	register	LineTyp	*lt;
	register	int		i, j;

	for (j = 0; j < MAXLAYER; j++)
	{
		lt = l_track[j].l;
		for (i = 0; i < l_track[j].n; i++, lt++)
			set_dir(lt);
	}
	info.changed = TRUE;
}

