/*****************************************************

		Platinen Layout fr ATARI ST in TURBO C
					Thomas Nau (c) 1990
	license: GNU GPL 2+ (see ../COPYING)

*****************************************************/

/* Standart INCLUDE files */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <tos.h>

#define L_PRT_C

#include "l_incl.h"     /* alle anderen INCLUDE Files */

/******************************************

		gibt Loetauge aus

******************************************/
void print_dot(n)
int n;
{
	register	DotTyp	*dt;
	register	long	divx, divy;
				long	x, y, x1, x2, x3, x4;
				int		s, y1, y2, y3, y4;

	dt = d_data.d +n;
	prt_coord(dt->x, dt->y, &x, &y);
	s = dt->s;
	x3 = x+ prt_dot[s].out[2].x;
	x4 = x+ prt_dot[s].out[1].x;
	y1 = (int) (y+ prt_dot[s].out[2].y);
	y2 = (int) (y+ prt_dot[s].out[3].y);
	y3 = (int) (y+ prt_dot[s].out[4].y);
	y4 = (int) (y+ prt_dot[s].out[5].y);
	divx = prt.xres;
	divy = prt.yres;
	x1 = x3 *divy;
	x2 = x4 *divy;
	while (y1 < y2)
	{
		p_chline((int) x3, (int) x4, y4--);
		p_chline((int) x3, (int) x4, y1++);
		x1 -= divx;
		x2 += divx;
		x3 = x1 /divy;
		x4 = x2 /divy;
	}
	p_cblk((int) x3, y2, (int) x4, y3);
	x3 = x+ prt_dot[s].in[2].x;
	x4 = x+ prt_dot[s].in[1].x;
	y1 = (int) (y+ prt_dot[s].in[2].y);
	y2 = (int) (y+ prt_dot[s].in[3].y);
	y3 = (int) (y+ prt_dot[s].in[4].y);
	y4 = (int) (y+ prt_dot[s].in[5].y);
	x1 = x3 *divy;
	x2 = x4 *divy;
	while (y1 < y2)
	{
		p_chdlin((int) x3, (int) x4, y4--);
		p_chdlin((int) x3, (int) x4, y1++);
		x1 -= divx;
		x2 += divx;
		x3 = x1 /divy;
		x4 = x2 /divy;
	}
	p_cdblk((int) x3, y2, (int) x4, y3);
}

/******************************************

		gibt Element aus

******************************************/
void print_ele(n)
int	n;
{
	register	EleTyp	*et;
				long	x1, x2, y1, y2;
				TextTyp	t;

	et = element.e +n;
	t.mir = FALSE;
	t.rot = et->tr;
	t.x = t.x1 = t.x2 = et->tx;
	t.y = t.y1 = t.y2 = et->ty;
	strcpy(t.t, et->layname);
	strupr(t.t);
	prt_coord(et->x1, et->y1, &x1, &y1);
	prt_coord(et->x2, et->y2, &x2, &y2);
	p_cblk((int) x1, (int) y1, (int) x1, (int) y2);
	p_cblk((int) x2, (int) y1, (int) x2, (int) y2);
	p_chline((int) x1, (int) x2, (int) y1);
	p_chline((int) x1, (int) x2, (int) y2);
	prt_coord(et->mx-3, et->my-3, &x1, &y1);
	prt_coord(et->mx+3, et->my+3, &x2, &y2);
	p_cblk((int) x1, (int) y1, (int) x2, (int) y2);
	print_text(&t);
}

/******************************************

		gibt Flaeche aus

******************************************/
void print_area(l, n)
Lines	*l;
int 	n;
{
	register	AreaTyp	*at;
				long	x1, y1, x2, y2;

	at = l->a +n;
	prt_coord(at->x1, at->y1, &x1, &y1);
	prt_coord(at->x2, at->y2, &x2, &y2);
	p_cblk((int) x1, (int) y1, (int) x2, (int) y2);
}

/******************************************

		gibt Text aus

******************************************/
void print_text(tp)
TextTyp	*tp;
{
	register	int		i, dx;
	register	char	*s;
	register	int		x, y;
				Lines	line;
				LineTyp	lt;
	unsigned	int		k, save;

	line.l = &lt;
	x = tp->x;
	y = tp->y;
	s = tp->t;
	save = info.rot;
	info.rot = tp->rot;
	while (*s)
	{
		k = *s;
		if (keys[k].l)
		{
			if (tp->mir)
			{
				for (i = 0; i < keys[k].n; i++)
				{
					lt = *(keys[k].l +i);
					lt.x1 = keys[k].h.minx -lt.x1 +keys[k].h.maxx;
					lt.x2 = keys[k].h.minx -lt.x2 +keys[k].h.maxx;
					set_dir(&lt);
					rot_line(&lt, 1, x, y, &keys[k].h);
					print_track(&line, 0);
				}
			}
			else
				for (i = 0; i < keys[k].n; i++)
				{
					lt = *(keys[k].l +i);
					rot_line(&lt, 1, x, y, &keys[k].h);
					print_track(&line, 0);
				}
			dx = keys[k].h.maxx -keys[k].h.minx +2;
		}
		else
			dx = BLANKCHAR;
		switch(info.rot)
		{
			case 0 :	x += dx;
						break;
			case 1 :	y += dx;
						break;
			case 2 :	x -= dx;
						break;
			case 3 :	y -= dx;
						break;
			default:	break;
		}
		s++;
	}
	info.rot = save;
}

/******************************************

		gibt Track aus

******************************************/
void print_track(l, n)
Lines	*l;
int 	n;
{
	register	LineTyp	*lt;
	register	int		i, j;
	register	long	divx, divy;
				long	x1, x2, y1, y2, x3, x4;
				int		d, s;
				XY		p[8];

	lt = l->l +n;
	prt_coord(lt->x1, lt->y1, &x1, &y1);
	prt_coord(lt->x2, lt->y2, &x2, &y2);
	divx = prt.xres;
	divy = prt.yres;
	s = lt->s;
	d = lt->d;
	for (i = 0; i < 8; i++)
	{
		j = (i +d) & 0x07;
		if (i < 4)
		{
			p[i].x = (int) (x1+ prt_track[s].out[j].x);
			p[i].y = (int) (y1+ prt_track[s].out[j].y);
		}
		else
		{
			p[i].x = (int) (x2+ prt_track[s].out[j].x);
			p[i].y = (int) (y2+ prt_track[s].out[j].y);
		}
	}
	switch(d)
	{
		case 0 : p_cblk(p[3].x, p[3].y, p[7].x, p[7].y);
				 x1 = divy *p[3].x +divx;
				 x2 = divy *p[0].x -divx;
				 y1 = p[0].y -1;
				 y2 = p[4].y +1;
				 x3 = x1 /divy;
				 x4 = x2 /divy;
				 while (y1 >= p[2].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1--);
				 	p_chline((int) x3, (int) x4, (int) y2++);
				 	x1 += divx;
				 	x2 -= divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
				 break;
		case 1 : x3 = p[1].x;
				 x4 = p[0].x;
				 x1 = x3 *divy;
		         x2 = x4 *divy;
				 y1 = p[1].y;
				 while (y1 < p[2].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 -= divx;
				 	x2 += divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
				 while (y1 < p[3].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x2 += divx;
				 	x4 = x2 /divy;
				 }
				 if (y1 < 0)
				 {
				 	if (p[7].y < 0)
				 	{
				 		x1 -= ((y1 -(long) p[7].y) *divx);
				 		x2 -= ((y1 -(long) p[7].y) *divx);
				 		y1 = p[7].y;
				 	}
				 	else
				 	{
				 		x1 -= (y1 *divx);
				 		x2 -= (y1 *divx);
						y1 = 0;
					}
				 }
				 x3 = x1 /divy;
				 x4 = x2 /divy;
				 while (y1 < p[7].y)
				 {
				 	if (y1 > prt.ymax) return;
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 += divx;
				 	x2 += divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
				 while (y1 < p[6].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 += divx;
				 	x3 = x1 /divy;
				 }
				 while (y1 <= p[4].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 += divx;
				 	x2 -= divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
				 break;
		case 2 : p_cblk(p[1].x, p[1].y, p[5].x, p[5].y);
				 x1 = divy *p[1].x +divx;
				 x2 = divy *p[6].x -divx;
				 y1 = p[6].y -1;
				 y2 = p[5].y +1;
				 x3 = x1 /divy;
		         x4 = x2 /divy;
				 while (y1 >= p[0].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1--);
				 	p_chline((int) x3, (int) x4, (int) y2++);
				 	x1 += divx;
				 	x2 -= divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
				 break;
		case 3 : x3 = p[7].x;
				 x4 = p[6].x;
				 x1 = x3 *divy;
		         x2 = x4 *divy;
				 y1 = p[7].y;
				 while (y1 < p[5].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 -= divx;
				 	x2 += divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
				 while (y1 < p[4].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 -= divx;
				 	x3 = x1 /divy;
				 }
				 if (y1 < 0)
				 {
				 	if (p[0].y < 0)
				 	{
				 		x1 += ((y1 - (long) p[0].y) *divx);
				 		x2 += ((y1 - (long) p[0].y) *divx);
				 		y1 = p[0].y;
				 	}
				 	else
				 	{
				 		x1 += (y1 *divx);
				 		x2 += (y1 *divx);
						y1 = 0;
					}
				 }
				 x3 = x1 /divy;
				 x4 = x2 /divy;
				 while (y1 < p[0].y)
				 {
				 	if (y1 > prt.ymax) return;
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 -= divx;
				 	x2 -= divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
				 while (y1 < p[1].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x2 -= divx;
				 	x4 = x2 /divy;
				 }
				 while (y1 <= p[2].y)
				 {
				 	p_chline((int) x3, (int) x4, (int) y1++);
				 	x1 += divx;
				 	x2 -= divx;
				 	x3 = x1 /divy;
				 	x4 = x2 /divy;
				 }
		default :break;
	}
}

/******************************************

		berechnet Druckerkoordinaten

******************************************/
void prt_coord(x, y, xr, yr)
int		x, y;
long	*xr, *yr;
{
	*xr = (long) (prt.zoomx * (double) x -prt.offx);
	*yr = (long) (prt.zoomy * (double) y -prt.offy);
}

/******************************************

		initialisiert Pins und Track

******************************************/
void pinit_dl()
{
	int		j;

	for (j = 0; j < LINETYPES; j++)
		pinit_line(linewidth[j], &prt_track[j]);
	for (j = 0; j < DOTTYPES; j++)
		pinit_dot(dotwidth[j], &prt_dot[j]);
}

/******************************************

		initialisiert tracklayout

******************************************/
void pinit_line(r, ll)
int			r;
LPrintout	*ll;
{
	FXY		p[8];
	double	zx, zy, c;
	int		i;

	c = 0.5 *tan(M_PI *22.5 /180.0);
	p[0].x = p[5].y = p[6].y = p[7].x = 0.5;
	p[1].y = p[2].y = p[3].x = p[4].x = -0.5;
	p[1].x = p[4].y = p[6].x = p[7].y = c;
	p[0].y = p[2].x = p[3].y = p[5].x = -c;
	zx = prt.zoomx *r *prt.lzoom;
	zy = prt.zoomy *r *prt.lzoom;
	for (i = 0; i < 8; i++)
	{
		ll->out[i].x = (long) (p[i].x *zx);
		ll->out[i].y = (long) (p[i].y *zy);
	}
}

/******************************************

		initialisiert Pinlayout

******************************************/
void pinit_dot(r, dl)
int			r;
DPrintout	*dl;
{
	FXY		p[8];
	double	zx, zy, zdx, zdy, c;
	int		i;

	c = 0.5 *tan(M_PI *22.5 /180.0);
	p[0].x = p[5].y = p[6].y = p[7].x = 0.5;
	p[1].y = p[2].y = p[3].x = p[4].x = -0.5;
	p[1].x = p[4].y = p[6].x = p[7].y = c;
	p[0].y = p[2].x = p[3].y = p[5].x = -c;
	zx  = prt.zoomx *prt.dzoom *r;
	zdx = prt.zoomx *prt.dzoom *PRTHOLE;
	zy  = prt.zoomy *prt.dzoom *r;
	zdy = prt.zoomy *prt.dzoom *PRTHOLE;
	for (i = 0; i < 8; i++)
	{
		dl->in[i].x = (long) (p[i].x *zdx);
		dl->in[i].y = (long) (p[i].y *zdy);
		dl->out[i].x = (long) (p[i].x *zx);
		dl->out[i].y = (long) (p[i].y *zy);
	}
}

/******************************************

		initialisiert Printerdaten

******************************************/
void pinit_data(pn)
char *pn;
{
			int		i;
	static	PData	printer_data[] = {{"DEFAULT", 0,
										0, 0,
										100, 100,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										NULL, 0L},
									  {"JET", 0,
										0, 0,
										300, 300,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										NULL, 0L},
									  {"FX", 0,
										0, 0,
										240, 216,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										NULL, 0L},
									  {"LQ", 0,
										0, 0,
										180, 180,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										0.0, 0.0,
										NULL, 0L}};
			long	printer_number;
	
	if (pn == NULL)
		pn = getenv("PRINTER");
	printer_number = sizeof(printer_data) / sizeof(PData);
	for (i = 0; i < printer_number && pn != NULL; i++)
		if (!strcmp(pn, printer_data[i].name))
		{
			prt.name = printer_data[i].name;
			prt.xres = printer_data[i].xres;
			prt.yres = printer_data[i].yres;
			prt.xy = (double) prt.xres / (double) prt.yres;
			prt.zoomx = 0.01 *prt.xres *prt.zoom;
			prt.zoomy = 0.01 *prt.yres *prt.zoom;
			return;
		}
	prt.name = printer_data[0].name;
	prt.xres = printer_data[0].xres;
	prt.yres = printer_data[0].yres;
	prt.xy = (double) prt.xres / (double) prt.yres;
	prt.zoomx = 0.01 *prt.xres *prt.zoom;
	prt.zoomy = 0.01 *prt.yres *prt.zoom;
}

/******************************************

		Printermenue

******************************************/
void p_menu(prt_file)
char *prt_file;
{
	static	char	s[81],
					pn[81];
			int		ok;
			long	ch;

	ok = FALSE;
	pinit_data(prt.name);
	do
	{
		sprintf(s, "zoom=%4.1lf dzoom=%5.2lf lzoom=%5.2lf prt= %s del= %c  (Pdlpqsz)",
				prt.zoom, prt.dzoom, prt.lzoom,
				prt.name, ((prt.deldot) ? 'y' : 'n'));
		o_clrstat();
		o_status(s);
		while (!Cconis());
		ch = (Cnecin()) & 0xff;
		switch ((char) ch)
		{
			case	'P'	:	print_it(prt_file);
							ok = TRUE;
							break;
			case	'd'	:	prt.deldot = !prt.deldot;
							break;
			case	'l' :	if ((prt.lzoom += 0.05) > PRTLDZ)
								prt.lzoom = 0.5;
							break;
			case	'p' :	if ((prt.dzoom += 0.05) > PRTLDZ)
								prt.dzoom = 0.5;
							break;
			case	'q'	:	ok = TRUE;
							break;
			case	's'	:	strcpy(pn, "");
							if (get_instr("printer: ", pn))
								pinit_data(pn);
							break;
			case	'z'	:	if ((prt.zoom += 0.1) > PRTZOOM)
								prt.zoom = 0.4;
							break;
			default		:	break;
		}
	} while (!ok);
	o_clrstat();
}

/******************************************

		Ausdrucksteuerung

******************************************/
void print_it(file)
char *file;
{
	register	int		i, j, k, found;
	register	DotTyp	*dp;
				long	xsize, ysize, maxy;
				int		x, y;
				FILE	*fp;
				char	s[81];
				char	*mem;

	o_clrstat();
	o_status("init printer data...");
	pinit_data(prt.name);
	pinit_dl();
	prt.offx = 0.0;
	prt.offy = 0.0;
	prt_coord(act_block.x1, act_block.y1, &prt.offx, &prt.offy);
	prt_coord(act_block.x2, act_block.y2, &prt.xmax, &prt.ymax);
	maxy = (long) (prt.ymax +1.0);
	xsize = ((long) (prt.xmax +32.0 +1.0)) /16;
	xsize *= 2;
	ysize = maxy;
	x = (int) xsize;
	y = (int) ysize;
	mem = NULL;
	while (ysize >= 1 && (mem = malloc(xsize *ysize +1L)) == NULL)
		ysize--;
	if (mem == NULL)
	{
		say_error("out of memory...");
		return;
	}
	prt.buffer = (void *) ((long) (mem +1) & (long) 0xfffffffe);
	o_clrstat();
	o_status("open printer file...");
	if ((fp = fopen(file, "wb")) == NULL)
	{
		say_error("can't open printer file");
		free(mem);
		return;
	}
	if (fwrite(&x, sizeof(int), 1, fp) != 1 ||
		fwrite(&y, sizeof(int), 1, fp) != 1)
	{
		say_error("can't write printer data");
		free(mem);
		fclose(fp);
		return;
	}
	while (maxy > 0)
	{
		if (ysize > maxy)
			ysize = maxy;
		prt.ymax = ysize -1.0;
		p_init(prt.buffer, (int) prt.xmax, (int) prt.ymax, x);
		o_clrstat();
		o_status("clearing buffer...");
		prt.buf_len = xsize * ysize;
		memset(prt.buffer, 0, prt.buf_len);
		for (i = 0; i < MAXLAYER; i++)
			if (l_track[i].on)
			{
				o_clrstat();
				sprintf(s, "printing layer %d, %d lines...", i+1, l_track[i].n);
				o_status(s);
				for (j = 0; j < l_track[i].n; j++)
					print_track(&l_track[i], j);
				for (j = 0; j < l_track[i].na; j++)
					print_area(&l_track[i], j);
				for (j = 0; j < l_track[i].nt; j++)
					print_text(l_track[i].t +j);
			}
		if (element.on)
		{
			o_clrstat();
			sprintf(s, "printing elements, %d elements...", element.n);
			o_status(s);
			for (j = 0; j < element.n; j++)
				print_ele(j);
		}
		if (d_data.on)
		{
			o_clrstat();
			sprintf(s, "printing dot layer, %d dots...", d_data.n);
			o_status(s);
			if (prt.deldot)
			{
				dp = d_data.d;
				for (j = 0; j < d_data.n; j++, dp++)
				{
					k = 0;
					found = FALSE;
					while(k < MAXLAYER && !found)
						if (l_track[k].on)
						{
							if ((found = is_connected(dp, k++)) == TRUE)
								print_dot(j);
						}
						else
							k++;
				}
			}
			else
				for (j = 0; j < d_data.n; j++)
					print_dot(j);
		}
		o_clrstat();
		o_status("writing buffer to disk...");
		if (fwrite(prt.buffer, xsize, ysize, fp) != ysize)
		{
			say_error("can't write printer data");
			free(mem);
			fclose(fp);
			return;
		}
		fflush(fp);
		maxy -= ysize;
		prt.offy += ysize;
	}
	fflush(fp);
	fclose(fp);
	free(mem);
}
