/* minialistic TOS-emulation layer for router */
/* (C) 2018 Tibor 'Igor2' Palinkas - license: GNU GPL 2+ (see ../COPYING) */

#include <SDL.h>

typedef struct
{
	int gcurx, gcury;   /* mouse cursor, current x;y coords */
	unsigned mouse_bt;  /* mouse button, current status  */

	/* SDL public */
	SDL_Renderer *rend;
	SDL_Window *win;
} VDIESC;

typedef struct {
	int fnt_dta;
} FONT;

typedef struct {
	FONT *font[2];
} FONTS;

extern VDIESC *Vdiesc;
extern FONT Font[2];
extern FONTS *Fonts;

void linea_init(void);

void *Physbase(void);

void hide_mouse(void);

/* Only func is implemented: 0=hide, 1=show */
void Cursconf(int func, int rate);

/*** extras ***/

/* Wait for events with a timeout */
int wait_event(int timeout);

/* sleep until the next event is received */
void idle_until_event(void);

int font_draw_char(int x0, int y0, int chr);
