/* (C) 2018 Tibor 'Igor2' Palinkas - license: GNU GPL 2+ (see ../COPYING) */

#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "tos.h"
#include "linea.h"

int Cconis(void)
{
	if (kbd_pin_next != kbd_pout_next)
		return 1;
	wait_event(10);
	return (kbd_pin_next != kbd_pout_next);
}

unsigned int Cnecin(void)
{
	return kbd_pop();
}

int findnext(struct ffblk *buf)
{
	struct dirent *de;
	if (buf->dir == NULL)
		return -1;
	de = readdir(buf->dir);
	if (de == NULL)
		return -1;
	buf->ff_name = de->d_name;
	return 0;
}

int findfirst(const char *path, struct ffblk *buf, int ignored)
{
	int len = strlen(path);
	char tmp[1024];

	if ((len > 4) && (strcmp(path+len-4, "\\*.*") == 0)) {
		if (len >= sizeof(tmp))
			return -1;
		memcpy(tmp, path, len-4);
		tmp[len-4] = '\0';
		path = tmp;
	}

	buf->dir = opendir(path);
	return findnext(buf);
}



int Fattrib(char *path, int wflag, int attrib)
{
	struct stat buf;
	return stat(path, &buf);
}


char *strlwr(char *str)
{
	char *s;
	for(s = str;*s != '\0'; s++)
		*s = tolower(*s);
	return str;
}

char *strupr(char *str)
{
	char *s;
	for(s = str;*s != '\0'; s++)
		*s = toupper(*s);
	return str;
}

void delay(int ms)
{
	SDL_RenderPresent(Vdiesc->rend);
	usleep((long)ms * 1000L);
}


unsigned int kbd_buf[KBD_BUF_MAX];
int kbd_pin_next = 0, kbd_pout_next = 0;

void kbd_push(unsigned int key)
{
	if ((kbd_pout_next == 0) && (kbd_pin_next == KBD_BUF_MAX))
		return; /* full */

	if (kbd_pin_next == kbd_pout_next - 1)
		return; /* full */

	kbd_buf[kbd_pin_next] = key;
	kbd_pin_next = (kbd_pin_next + 1) % KBD_BUF_MAX;
}

unsigned int kbd_pop(void)
{
	int ret;

	if (kbd_pin_next == kbd_pout_next)
		return -1;

	ret = kbd_buf[kbd_pout_next];
	kbd_pout_next = (kbd_pout_next + 1) % KBD_BUF_MAX;

	return ret;
}

