/* minialistic TOS-emulation layer for router */
/* (C) 2018 Tibor 'Igor2' Palinkas - license: GNU GPL 2+ (see ../COPYING) */

#include <sys/types.h>
#include <dirent.h>

/*** console ***/

/* non-zero if character is waiting in the input buffer */
int Cconis(void);

/* read one char from stdin without echo */
unsigned int Cnecin(void);

/*** fs ***/
struct ffblk {
	char *ff_name;
	DIR *dir;
};

int findfirst(const char *path, struct ffblk *buf, int ignored);
int findnext(struct ffblk *buf);

/* could be a stat() wrapper, but router uses it only to figure if a file
   exists (>=0) or not (<0) */
int Fattrib(char *path, int wflag, int attrib);

/*** str ***/
/* tolower() and toupper() on each char */
char *strlwr(char *str);
char *strupr(char *str);


/*** misc ***/
void delay(int ms);


/*** internal ***/

#define KBD_BUF_MAX 32
extern unsigned int kbd_buf[KBD_BUF_MAX];
extern int kbd_pin_next, kbd_pout_next;

void kbd_push(unsigned int key);
unsigned int kbd_pop(void);
